#ifndef _FOURIER1
#define _FOURIER1

/* fourier1.f -- translated by f2c (version 20041007).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/
#include <math.h>

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal t[2], freq;
} tempo_;

#define tempo_1 tempo_

union {
    struct {
	doublereal work[12936];
    } _1;
    struct {
	doublereal work[1];
    } _2;
} work_;

#define work_1 (work_._1)
#define work_2 (work_._2)

union {
    struct {
	integer ifax1[13];
    } _1;
    struct {
	integer ifax1[1];
    } _2;
} ifax1_;

#define ifax1_1 (ifax1_._1)
#define ifax1_2 (ifax1_._2)

union {
    struct {
	integer ifax2[13];
    } _1;
    struct {
	integer ifax2[1];
    } _2;
} ifax2_;

#define ifax2_1 (ifax2_._1)
#define ifax2_2 (ifax2_._2)

union {
    struct {
	doublereal ex1[196];
    } _1;
    struct {
	doublereal ex1[1];
    } _2;
} ex1_;

#define ex1_1 (ex1_._1)
#define ex1_2 (ex1_._2)

union {
    struct {
	doublereal ex2[132];
    } _1;
    struct {
	doublereal ex2[1];
    } _2;
} ex2_;

#define ex2_1 (ex2_._1)
#define ex2_2 (ex2_._2)

struct {
    integer nproc[13];
} optsb_;

#define optsb_1 optsb_

struct {
    integer normal;
} normal_;

#define normal_1 normal_

/* Table of constant values */

static integer c96 = 96;
static integer c64 = 64;
static integer c1 = 1;
static integer c_n1 = -1;
static integer c2 = 2;

/* ______________________________________________________________________ */
/* Subroutine */ 


int fourier1_( doublecomplex *u, doublecomplex *v, doublecomplex *w, 
			         doublereal *uo, doublereal *vo, doublereal *wo)
{
    /* Format strings */
    static char fmt_9910[] = "(\002IERROR=\002,i2,\002Nx o Nz CONTAIN FACTOR"
	    "S OTHER THAN 2,3,5\002)";

    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double d_imag(doublecomplex *);
    integer s_wsfe(cilist *), do_fio(integer *, char *, ftnlen), e_wsfe(void);

    /* Local variables */
    static doublereal a[6468]	/* was [98][66] */;
    static integer ii, j, k;
    extern /* Subroutine */ int rffi_(doublereal *, integer *, integer *), 
	    rffp_(doublereal *, doublereal *, integer *, integer *, integer *,
	     integer *);
    static integer indice, ierror;

    /* Fortran I/O blocks */
    static cilist io___7 = { 0, 6, 0, fmt_9910, 0 };


/*      implicit none */
/*      INTEGER*4 NXF,NYF,NZF */
/*      PARAMETER(NXF=NX/2, NYF=NY/2+1,NZF=NZ/2,ip=2) */

    /* Parameter adjustments */
    wo -= 15812;
    vo -= 15812;
    uo -= 15812;
    w -= 7010;
    v -= 7010;
    u -= 7010;


    /* Function Body */
    rffp_(ex1_1.ex1, ex2_1.ex2, ifax1_1.ifax1, ifax2_1.ifax2, &c96, &c64);
    if (ifax1_1.ifax1[0] == -99 || ifax1_1.ifax1[1] == -99) {
	goto L991;
    }
/* - COMPONENTE DI VELOCITA' U - */
    for (j = 1; j <= 161; ++j) {
	for (k = 1; k <= 66; ++k) {
	    for (ii = 1; ii <= 98; ++ii) {
		a[ii + k * 98 - 99] = 0.;
	    }
	}
/* - coeff. di Fourier C_k  (k=0, k=1,nwaz) - */
	for (k = 1; k <= 29; ++k) {
	    indice = 0;
	    for (ii = 1; ii <= 43; ++ii) {
		indice += 2;
		ii1 = ii + (j + k * 163) * 43;
		a[indice - 1 + k * 98 - 99] = u[ii1].r;
		a[indice + k * 98 - 99] = d_imag(&u[ii + (j + k * 163) * 43])
			;
	    }
	}
/* - coeff. di Fourier C_(Nz-k)  (k=1,nwaz) - */
	for (k = 1; k <= 28; ++k) {
	    indice = 0;
	    for (ii = 1; ii <= 43; ++ii) {
		indice += 2;
		ii1 = ii + (j + (57 - (k - 1)) * 163) * 43;
		a[indice - 1 + (64 - (k - 1)) * 98 - 99] = u[ii1].r;
		a[indice + (64 - (k - 1)) * 98 - 99] = d_imag(&u[ii + (j + (
			57 - (k - 1)) * 163) * 43]);
	    }
	}
	rffi_(a, &c96, &c64);
	for (k = 1; k <= 64; ++k) {
	    for (ii = 1; ii <= 96; ++ii) {
				//printf("%d %d\n",ii + (j + k * 163) * 97, ii + k * 98 - 99);
		uo[ii + (j + k * 163) * 97] = a[ii + k * 98 - 99];
	    }
	}
    }
/* - COMPONENTE DI VELOCITA' V - */
    for (j = 1; j <= 161; ++j) {
	for (k = 1; k <= 64; ++k) {
	    for (ii = 1; ii <= 98; ++ii) {
		a[ii + k * 98 - 99] = 0.;
	    }
	}
/* - coeff. di Fourier C_k  (k=0, k=1,nwaz) - */
	for (k = 1; k <= 29; ++k) {
	    indice = 0;
	    for (ii = 1; ii <= 43; ++ii) {
		indice += 2;
		ii1 = ii + (j + k * 163) * 43;
		a[indice - 1 + k * 98 - 99] = v[ii1].r;
		a[indice + k * 98 - 99] = d_imag(&v[ii + (j + k * 163) * 43])
			;
	    }
	}
/* - coeff. di Fourier C_(Nz-k)  (k=1,nwaz) - */
	for (k = 1; k <= 28; ++k) {
	    indice = 0;
	    for (ii = 1; ii <= 43; ++ii) {
		indice += 2;
		ii1 = ii + (j + (57 - (k - 1)) * 163) * 43;
		a[indice - 1 + (64 - (k - 1)) * 98 - 99] = v[ii1].r;
		a[indice + (64 - (k - 1)) * 98 - 99] = d_imag(&v[ii + (j + (
			57 - (k - 1)) * 163) * 43]);
	    }
	}
	rffi_(a, &c96, &c64);
	for (k = 1; k <= 64; ++k) {
	    for (ii = 1; ii <= 96; ++ii) {
		vo[ii + (j + k * 163) * 97] = a[ii + k * 98 - 99];
	    }
	}
    }
/* - COMPONENTE DI VELOCITA' W - */
    for (j = 1; j <= 161; ++j) {
	for (k = 1; k <= 64; ++k) {
	    for (ii = 1; ii <= 98; ++ii) {
		a[ii + k * 98 - 99] = 0.;
	    }
	}
/* - coeff. di Fourier C_k  (k=0, k=1,nwaz) - */
	for (k = 1; k <= 29; ++k) {
	    indice = 0;
	    for (ii = 1; ii <= 43; ++ii) {
		indice += 2;
		ii1 = ii + (j + k * 163) * 43;
		a[indice - 1 + k * 98 - 99] = w[ii1].r;
		a[indice + k * 98 - 99] = d_imag(&w[ii + (j + k * 163) * 43])
			;
	    }
	}
/* - coeff. di Fourier C_(Nz-k)  (k=1,nwaz) - */
	for (k = 1; k <= 28; ++k) {
	    indice = 0;
	    for (ii = 1; ii <= 43; ++ii) {
		indice += 2;
		ii1 = ii + (j + (57 - (k - 1)) * 163) * 43;
		a[indice - 1 + (64 - (k - 1)) * 98 - 99] = w[ii1].r;
		a[indice + (64 - (k - 1)) * 98 - 99] = d_imag(&w[ii + (j + (
			57 - (k - 1)) * 163) * 43]);
	    }
	}
	rffi_(a, &c96, &c64);
	for (k = 1; k <= 64; ++k) {
	    for (ii = 1; ii <= 96; ++ii) {
		wo[ii + (j + k * 163) * 97] = a[ii + k * 98 - 99];
	    }
	}
    }
/*  Condizioni al contorno in direzione y */
    for (ii = 1; ii <= 96; ++ii) {
	for (k = 1; k <= 64; ++k) {
	    uo[ii + k * 15811] = -uo[ii + (k * 163 + 2) * 97];
	    ii1 = ii + (k * 163 + 1) * 97;
	    uo[ii1] = 0.;
	    ii1 = ii + (k * 163 + 161) * 97;
	    uo[ii1] = 0.;
/* 	      uo(i,Ny,k)=cos(freq*t(2)) */
	    uo[ii + (k * 163 + 162) * 97] = -uo[ii + (k * 163 + 160) * 97];
	    vo[ii + k * 15811] = vo[ii + (k * 163 + 2) * 97];
	    ii1 = ii + (k * 163 + 1) * 97;
	    vo[ii1] = 0.;
	    ii1 = ii + (k * 163 + 161) * 97;
	    vo[ii1] = 0.;
	    vo[ii + (k * 163 + 162) * 97] = vo[ii + (k * 163 + 160) * 97];
	    wo[ii + k * 15811] = -wo[ii + (k * 163 + 2) * 97];
	    ii1 = ii + (k * 163 + 1) * 97;
	    wo[ii1] = 0.;
	    ii1 = ii + (k * 163 + 161) * 97;
	    wo[ii1] = 0.;
/* 	      wo(i,Ny,k)=sin(freq*t(2)) */
	    wo[ii + (k * 163 + 162) * 97] = -wo[ii + (k * 163 + 160) * 97];
	}
    }
/*  Condizioni periodiche */
    for (j = 0; j <= 162; ++j) {
	for (k = 1; k <= 64; ++k) {
	    uo[(j + k * 163) * 97 + 97] = uo[(j + k * 163) * 97 + 1];
	    vo[(j + k * 163) * 97 + 97] = vo[(j + k * 163) * 97 + 1];
	    wo[(j + k * 163) * 97 + 97] = wo[(j + k * 163) * 97 + 1];
	}
    }
    for (j = 0; j <= 162; ++j) {
	for (ii = 1; ii <= 96; ++ii) {
	    uo[ii + (j + 10595) * 97] = uo[ii + (j + 163) * 97];
	    vo[ii + (j + 10595) * 97] = vo[ii + (j + 163) * 97];
	    wo[ii + (j + 10595) * 97] = wo[ii + (j + 163) * 97];
	}
    }
    return 0;
L991:
    ierror = 1;
    s_wsfe(&io___7);
    do_fio(&c1, (char *)&ierror, (ftnlen)sizeof(integer));
    e_wsfe();
    return 0;
} /* fourier1_ */

/* Subroutine */ int rffp_(doublereal *ex1, doublereal *ex2, integer *ifax1, 
	integer *ifax2, integer *n1, integer *n2)
{
    extern /* Subroutine */ int cfftst_(doublereal *, integer *, integer *), 
	    rfftst_(doublereal *, integer *, integer *);

/* *****---------------*************************** */
    rfftst_(ex1, ifax1, n1);
    cfftst_(ex2, ifax2, n2);
    return 0;
} /* rffp_ */

/* Subroutine */ int rffd_(doublereal *u, integer *n1, integer *n2)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    extern /* Subroutine */ int cfftsb_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *), rfftsb_(doublereal *, doublereal *, doublereal *, 
	    integer *, integer *, integer *, integer *, integer *, integer *);

/* *****---------------*************************** */
    ii1 = *n1 + 2;
    rfftsb_(u, work_2.work, ex1_2.ex1, ifax1_2.ifax1, &c1, &ii1, n1, n2, &
	    c_n1);
    ii1 = (*n1 + 2) / 2;
    ii2 = (*n1 + 2) / 2;
    cfftsb_(u, work_2.work, ex2_2.ex2, ifax2_2.ifax2, &ii1, &c1, n2, &ii2,
	     &c_n1);
    return 0;
} /* rffd_ */

/* Subroutine */ int rffi_(doublereal *u, integer *n1, integer *n2)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    extern /* Subroutine */ int cfftsb_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *), rfftsb_(doublereal *, doublereal *, doublereal *, 
	    integer *, integer *, integer *, integer *, integer *, integer *);

/* *****---------------*************************** */
    ii1 = (*n1 + 2) / 2;
    ii2 = (*n1 + 2) / 2;
    cfftsb_(u, work_2.work, ex2_2.ex2, ifax2_2.ifax2, &ii1, &c1, n2, &ii2,
	     &c1);
    ii1 = *n1 + 2;
    rfftsb_(u, work_2.work, ex1_2.ex1, ifax1_2.ifax1, &c1, &ii1, n1, n2, &
	    c1);
    return 0;
} /* rffi_ */

/* ***********---------------------------------------******************** */
/*     SBFOR : Any machine using a Fortran Version of FFT991 and CFFT99 */
/* *****-----------------------------------------------------------****** */
/*       Standard Basic subroutines version 2.01  18-01-90 */

/*  1. Content : */

/*            rfftst : initialisations for rfftsb */
/*            rfftsb : real Fast Fourier transform */

/*            cfftst : initialisations for cfftsb */
/*            cfftsb : complex fast Fourier Transform */

/*            rcosst : initialisations for rcossb */
/*            rcossb : real fast cosine transform */

/*            ccosst : initialisations for ccossb */
/*            ccossb : complex fast cosine transform */

/*            rsinst : initialisations for rsinsb */
/*            rsinsb : real  fast sine transform */

/*            rsymst : initialisations for rsymsb */
/*            rsymsb : real symetric fast Fourier transform */

/*            csymst : initialisations for csymsb */
/*            csymsb : complex symetric fast Fourier transform */

/*            rantst : initialisations for rantsb */
/*            rantsb : real antisymetric fast Fourier transform */

/*  2. Internal subroutine used : */
/*       the package Temperton FFT991 and CFFT99 for real  and complex ffts */




/*  3. NB : in this version priviledging  real ftt fft991 it is choosen: */
/*       rfftsb uses the real Temperton fft991 */
/*       cfftsb uses the complex Temperton cfft99 */
/*       rcossb uses rsymsb. (Thual) */
/*       ccossb uses rcossb. */
/*       rsinsb uses rantsb. (Thual) */
/*       rsymsb uses rfftsb. (Brachet) */
/*       rantb uses  rfftsb. (Brachet) */


/* ********************************************************************** */
/* Subroutine */ int rfftst_(doublereal *ex, integer *ifax, integer *n)
{
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------*********** */
    fftfax_(n, ifax, ex);
    return 0;
} /* rfftst_ */

/* Subroutine */ int rfftsb_(doublereal *u, doublereal *work, doublereal *ex, 
	integer *ifax, integer *inc, integer *jump, integer *n, integer *nft, 
	integer *isign)
{
    /* System generated locals */
    integer ii1;

    /* Local variables */
    static integer ii, i1, i2;
    extern /* Subroutine */ int fft991_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *);

/* *****-----------------************************************* */
    /* Parameter adjustments */
    --u;

    /* Function Body */
    if (*isign == -1) {
	ii1 = *nft;
	for (ii = 1; ii <= ii1; ++ii) {
	    i1 = (ii - 1) * *jump + *n * *inc + *inc;
	    i2 = i1 + *inc;
	    u[i1] = 0.;
	    u[i2] = 0.;
/* L10: */
	}
    }
    fft991_(&u[1], work, ex, ifax, inc, jump, n, nft, isign);
    return 0;
} /* rfftsb_ */

/* Subroutine */ int cfftst_(doublereal *ex, integer *ifax, integer *n)
{
    extern /* Subroutine */ int cftfax_(integer *, integer *, doublereal *);

/* *****-----------------*********** */
    cftfax_(n, ifax, ex);
    return 0;
} /* cfftst_ */

/* Subroutine */ int cfftsb_(doublereal *u, doublereal *work, doublereal *ex, 
	integer *ifax, integer *inc, integer *jump, integer *n, integer *nft, 
	integer *isign)
{
    extern /* Subroutine */ int cfft99_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *), ftnorm_(doublereal *, integer *, integer *, 
	    integer *, integer *, integer *);

/* *****-----------------*********** */
    cfft99_(u, work, ex, ifax, inc, jump, n, nft, isign);
    if (*isign == -1) {
	ftnorm_(u, n, inc, jump, nft, isign);
    }
    return 0;
} /* cfftsb_ */

/* Subroutine */ int rcosst_(doublereal *ex, integer *ifax, doublereal *ssini,
	 doublereal *ssinq, integer *npts)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double atan(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii;
    static doublereal pi, pih;
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------****************************** */
/* initialisation pour rsymsb */
    /* Parameter adjustments */
    --ssinq;
    --ssini;

    /* Function Body */
    fftfax_(npts, ifax, ex);
    pi = atan(1.f) * 4.f;
    pih = pi / 2.f;
    ii1 = *npts;
    for (ii = 2; ii <= ii1; ++ii) {
	ssini[ii] = .25f / sin(pi * (real) (ii - 1) / (real) (*npts));
	ssinq[ii] = sin(pi * (real) (ii - 1) / (real) (*npts));
/* L10: */
    }
    ssinq[1] = 0.f;
    ssinq[*npts + 1] = 0.f;
    return 0;
} /* rcosst_ */

/* Subroutine */ int rcossb_(doublereal *a, doublereal *work, doublereal *ex, 
	integer *ifax, doublereal *ssini, doublereal *ssinq, integer *inc, 
	integer *jump, integer *npts, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, ia, iv, ivec;
    extern /* Subroutine */ int rsymsb_(doublereal *, doublereal *, 
	    doublereal *, integer *, doublereal *, doublereal *, integer *, 
	    integer *, integer *, integer *, integer *);

/* *****-----------------****************************** */
/* physique spectral isign=1 :  ui=sum an cos nxi vers an */
/* spectral physique isign=-1:  an vers ui */
/*  physique spectral isign=-1 */
    /* Parameter adjustments */
    --ssinq;
    --ssini;
    --work;
    --a;

    /* Function Body */
    if (*isign == -1) {
	rsymsb_(&a[1], &work[1], ex, ifax, &ssini[1], &ssinq[1], inc, jump, 
		npts, nft, isign);
	ii1 = *npts;
	for (ii = 2; ii <= ii1; ++ii) {
/* DIR$ IVDEP */
	    ii2 = *nft;
	    for (iv = 1; iv <= ii2; ++iv) {
		ivec = (iv - 1) * *jump;
		ia = (ii - 1) * *inc + 1 + ivec;
		a[ia] *= 2.f;
/* L11: */
	    }
/* L100: */
	}
	return 0;
    }
/* inverse spectral physique isign=1 */
    if (*isign == 1) {
	ii1 = *npts;
	for (ii = 2; ii <= ii1; ++ii) {
/* DIR$ IVDEP */
	    ii2 = *nft;
	    for (iv = 1; iv <= ii2; ++iv) {
		ivec = (iv - 1) * *jump;
		ia = (ii - 1) * *inc + 1 + ivec;
		a[ia] *= .5f;
/* L21: */
	    }
/* L200: */
	}
	rsymsb_(&a[1], &work[1], ex, ifax, &ssini[1], &ssinq[1], inc, jump, 
		npts, nft, isign);
	return 0;
    }
    return 0;
} /* rcossb_ */

/* Subroutine */ int ccosst_(doublereal *ex, integer *ifax, doublereal *ssini,
	 doublereal *ssinq, integer *npts)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double atan(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii;
    static doublereal pi, pih;
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------****************************** */
    /* Parameter adjustments */
    --ssinq;
    --ssini;

    /* Function Body */
    fftfax_(npts, ifax, ex);
    pi = atan(1.f) * 4.f;
    pih = pi / 2.f;
    ii1 = *npts;
    for (ii = 2; ii <= ii1; ++ii) {
	ssini[ii] = .25f / sin(pi * (real) (ii - 1) / (real) (*npts));
	ssinq[ii] = sin(pi * (real) (ii - 1) / (real) (*npts));
/* L10: */
    }
    ssinq[1] = 0.f;
    ssinq[*npts + 1] = 0.f;
    return 0;
} /* ccosst_ */

/* Subroutine */ int ccossb_(doublereal *a, doublereal *work, doublereal *ex, 
	integer *ifax, doublereal *ssini, doublereal *ssinq, integer *inc, 
	integer *jump, integer *npts, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    extern /* Subroutine */ int rcossb_(doublereal *, doublereal *, 
	    doublereal *, integer *, doublereal *, doublereal *, integer *, 
	    integer *, integer *, integer *, integer *);

/* *****-----------------****************************** */
    /* Parameter adjustments */
    --ssinq;
    --work;
    --a;

    /* Function Body */
    ii1 = *inc << 1;
    ii2 = *jump << 1;
    rcossb_(&a[1], &work[1], ex, ifax, ssini, &ssinq[1], &ii1, &ii2, npts, 
	    nft, isign);
    ii1 = *inc << 1;
    ii2 = *jump << 1;
    rcossb_(&a[2], &work[1], ex, ifax, ssini, &ssinq[1], &ii1, &ii2, npts, 
	    nft, isign);
    return 0;
} /* ccossb_ */

/* Subroutine */ int rsinst_(doublereal *ex, integer *ifax, doublereal *ssini,
	 doublereal *ssinq, integer *npts)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double atan(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii;
    static doublereal pi, pih;
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------****************************** */
/* initialisation pour rsymsb */
    /* Parameter adjustments */
    --ssinq;
    --ssini;

    /* Function Body */
    fftfax_(npts, ifax, ex);
    pi = atan(1.f) * 4.f;
    pih = pi / 2.f;
    ii1 = *npts;
    for (ii = 2; ii <= ii1; ++ii) {
	ssini[ii] = .25f / sin(pi * (real) (ii - 1) / (real) (*npts));
	ssinq[ii] = sin(pi * (real) (ii - 1) / (real) (*npts));
/* L10: */
    }
    ssinq[1] = 0.f;
    ssinq[*npts + 1] = 0.f;
    return 0;
} /* rsinst_ */

/* Subroutine */ int rsinsb_(doublereal *a, doublereal *work, doublereal *ex, 
	integer *ifax, doublereal *ssini, doublereal *ssinq, integer *inc, 
	integer *jump, integer *npts, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, ia, iv, ivec;
    extern /* Subroutine */ int rantsb_(doublereal *, doublereal *, 
	    doublereal *, integer *, doublereal *, doublereal *, integer *, 
	    integer *, integer *, integer *, integer *);

/* *****-----------------****************************** */
/* physique spectral isign=1 :  ui=sum an sin nxi vers an */
/* spectral physique isign=-1:  an vers ui */
/*  physique spectral isign=-1 */
    /* Parameter adjustments */
    --ssinq;
    --ssini;
    --work;
    --a;

    /* Function Body */
    if (*isign == -1) {
	rantsb_(&a[1], &work[1], ex, ifax, &ssini[1], &ssinq[1], inc, jump, 
		npts, nft, isign);
	ii1 = *npts - 1;
	for (ii = 2; ii <= ii1; ++ii) {
/* DIR$ IVDEP */
	    ii2 = *nft;
	    for (iv = 1; iv <= ii2; ++iv) {
		ivec = (iv - 1) * *jump;
		ia = (ii - 1) * *inc + 1 + ivec;
		a[ia] *= 2.f;
/* L11: */
	    }
/* L100: */
	}
	return 0;
    }
/* inverse spectral physique isign=1 */
    if (*isign == 1) {
	ii1 = *npts - 1;
	for (ii = 2; ii <= ii1; ++ii) {
/* DIR$ IVDEP */
	    ii2 = *nft;
	    for (iv = 1; iv <= ii2; ++iv) {
		ivec = (iv - 1) * *jump;
		ia = (ii - 1) * *inc + 1 + ivec;
		a[ia] *= .5f;
/* L21: */
	    }
/* L200: */
	}
	rantsb_(&a[1], &work[1], ex, ifax, &ssini[1], &ssinq[1], inc, jump, 
		npts, nft, isign);
	return 0;
    }
    return 0;
} /* rsinsb_ */

/* Subroutine */ int rsymst_(doublereal *ex, integer *ifax, doublereal *ssini,
	 doublereal *ssinq, integer *npts)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double atan(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii;
    static doublereal pi, pih;
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------****************************** */
    /* Parameter adjustments */
    --ssinq;
    --ssini;

    /* Function Body */
    fftfax_(npts, ifax, ex);
    pi = atan(1.f) * 4.f;
    pih = pi / 2.f;
    ii1 = *npts;
    for (ii = 2; ii <= ii1; ++ii) {
	ssini[ii] = .25f / sin(pi * (real) (ii - 1) / (real) (*npts));
	ssinq[ii] = sin(pi * (real) (ii - 1) / (real) (*npts));
/* L10: */
    }
    ssinq[1] = 0.f;
    ssinq[*npts + 1] = 0.f;
    return 0;
} /* rsymst_ */

/* Subroutine */ int rsymsb_(doublereal *a, doublereal *work, doublereal *ex, 
	integer *ifax, doublereal *ssini, doublereal *ssinq, integer *inc, 
	integer *jump, integer *npts, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, ia, it, iv, iv2, iv3, ivec, isym;
    extern /* Subroutine */ int fft991_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *);

/* *****-----------------****************************** */
/* transformation cosinus reel basee sur temperton reel complex */
/* attention! ne marche que si la dimension du champ >=npts+3 */
    /* Parameter adjustments */
    --ssinq;
    --ssini;
    --work;
    --a;

    /* Function Body */
    if (*isign == -1) {
	goto L1000;
    }
/* cas spectral --> physique */
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	iv2 = iv + *nft;
	ivec = (iv - 1) * *jump;
	ia = *inc + 1 + ivec;
	work[iv] = a[ia];
	work[iv2] = a[ia];
	a[ia] = 0.f;
/* L10: */
    }
    ii1 = *npts;
    for (ii = 4; ii <= ii1; ii += 2) {
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    iv3 = iv2 + *nft;
	    ivec = (iv - 1) * *jump;
	    ia = (ii - 1) * *inc + 1 + ivec;
	    work[iv] += a[ia];
	    work[iv3] = a[ia];
	    a[ia] -= work[iv2];
	    work[iv2] = work[iv3];
/* L11: */
	}
/* L100: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[(*npts + 1) * *inc + ivec + 1] = 0.f;
	a[(*npts + 2) * *inc + ivec + 1] = work[iv] * 2.f;
/* L12: */
    }

    fft991_(&a[1], &work[1], ex, ifax, inc, jump, npts, nft, isign);

/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[*npts * *inc + ivec + 1] = a[ivec + 1] - a[(*npts + 2) * *inc + 
		ivec + 1];
	a[ivec + 1] += a[(*npts + 2) * *inc + ivec + 1];
/* L13: */
    }
    ii1 = *npts / 2;
    for (ii = 2; ii <= ii1; ++ii) {
	it = (ii - 1) * *inc + 1;
	isym = (*npts + 1 - ii) * *inc + 1;
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    work[iv] = (a[it + ivec] + a[isym + ivec]) * .5f;
	    work[iv2] = ssini[ii] * (a[it + ivec] - a[isym + ivec]);
	    a[it + ivec] = work[iv] + work[iv2];
	    a[isym + ivec] = work[iv] - work[iv2];
/* L14: */
	}
/* L110: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[(*npts + 1) * *inc + ivec + 1] = 0.f;
	a[(*npts + 2) * *inc + ivec + 1] = 0.f;
/* L15: */
    }
    return 0;
L1000:
/* cas physique --> spectral */
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[(*npts + 2) * *inc + ivec + 1] = (a[ivec + 1] - a[*npts * *inc + 
		ivec + 1]) * .25f;
	a[ivec + 1] = (a[ivec + 1] + a[*npts * *inc + ivec + 1]) * .5f;
/* L23: */
    }
    ii1 = *npts / 2;
    for (ii = 2; ii <= ii1; ++ii) {
	it = (ii - 1) * *inc + 1;
	isym = (*npts + 1 - ii) * *inc + 1;
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    work[iv] = (a[it + ivec] + a[isym + ivec]) * .5f;
	    work[iv2] = ssinq[ii] * (a[it + ivec] - a[isym + ivec]);
	    a[it + ivec] = work[iv] + work[iv2];
	    a[isym + ivec] = work[iv] - work[iv2];
/* L24: */
	}
/* L210: */
    }

    fft991_(&a[1], &work[1], ex, ifax, inc, jump, npts, nft, isign);

/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	iv2 = iv + *nft;
	ivec = (iv - 1) * *jump;
	ia = (*npts - 1) * *inc + ivec + 1;
	work[iv] = -a[ia];
	work[iv2] = -a[ia];
/* L20: */
    }
    for (ii = *npts - 2; ii >= 4; ii += -2) {
/* DIR$ IVDEP */
	ii1 = *nft;
	for (iv = 1; iv <= ii1; ++iv) {
	    ivec = (iv - 1) * *jump;
	    iv2 = iv + *nft;
	    ia = (ii - 1) * *inc + 1 + ivec;
	    work[iv] -= a[ia];
	    work[iv2] += work[iv];
/* L21: */
	}
/* L200: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	iv2 = iv + *nft;
	ivec = (iv - 1) * *jump;
	work[iv] = (a[*inc * (*npts + 2) + ivec + 1] - work[iv2]) / (real) (*
		npts / 2);
/* L22: */
    }
    for (ii = *npts; ii >= 4; ii += -2) {
/* DIR$ IVDEP */
	ii1 = *nft;
	for (iv = 1; iv <= ii1; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    ia = (ii - 1) * *inc + ivec + 1;
	    work[iv2] = a[ia];
	    a[ia] = work[iv];
	    work[iv] -= work[iv2];
/* L25: */
	}
/* L205: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	ia = *inc + ivec + 1;
	a[ia] = work[iv];
	a[(*npts + 1) * *inc + ivec + 1] = 0.f;
	a[(*npts + 2) * *inc + ivec + 1] = 0.f;
/* L26: */
    }
    return 0;
} /* rsymsb_ */

/* Subroutine */ int csymst_(doublereal *ex, integer *ifax, doublereal *ssini,
	 doublereal *ssinq, integer *npts)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double atan(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii;
    static doublereal pi, pih;
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------****************************** */
/* initialisation pour rsymsb */
    /* Parameter adjustments */
    --ssinq;
    --ssini;

    /* Function Body */
    fftfax_(npts, ifax, ex);
    pi = atan(1.f) * 4.f;
    pih = pi / 2.f;
    ii1 = *npts;
    for (ii = 2; ii <= ii1; ++ii) {
	ssini[ii] = .25f / sin(pi * (real) (ii - 1) / (real) (*npts));
	ssinq[ii] = sin(pi * (real) (ii - 1) / (real) (*npts));
/* L10: */
    }
    ssinq[1] = 0.f;
    ssinq[*npts + 1] = 0.f;
    return 0;
} /* csymst_ */

/* Subroutine */ int csymsb_(doublereal *a, doublereal *work, doublereal *ex, 
	integer *ifax, doublereal *ssini, doublereal *ssinq, integer *inc, 
	integer *jump, integer *m, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer npts;
    extern /* Subroutine */ int rsymsb_(doublereal *, doublereal *, 
	    doublereal *, integer *, doublereal *, doublereal *, integer *, 
	    integer *, integer *, integer *, integer *);

/* *****-----------------*************************** */
    /* Parameter adjustments */
    --ssinq;
    --ssini;
    --work;
    --a;

    /* Function Body */
    ii1 = *inc << 1;
    ii2 = *jump << 1;
    rsymsb_(&a[1], &work[1], ex, ifax, &ssini[1], &ssinq[1], &ii1, &ii2, &
	    npts, nft, isign);
    ii1 = *inc << 1;
    ii2 = *jump << 1;
    rsymsb_(&a[2], &work[1], ex, ifax, &ssini[1], &ssinq[1], &ii1, &ii2, &
	    npts, nft, isign);
    return 0;
} /* csymsb_ */

/* Subroutine */ int rantst_(doublereal *ex, integer *ifax, doublereal *ssini,
	 doublereal *ssinq, integer *npts)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double atan(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii;
    static doublereal pi, pih;
    extern /* Subroutine */ int fftfax_(integer *, integer *, doublereal *);

/* *****-----------------****************************** */
/* initialisation pour rsymsb */
    /* Parameter adjustments */
    --ssinq;
    --ssini;

    /* Function Body */
    fftfax_(npts, ifax, ex);
    pi = atan(1.f) * 4.f;
    pih = pi / 2.f;
    ii1 = *npts;
    for (ii = 2; ii <= ii1; ++ii) {
	ssini[ii] = .25f / sin(pi * (real) (ii - 1) / (real) (*npts));
	ssinq[ii] = sin(pi * (real) (ii - 1) / (real) (*npts));
/* L10: */
    }
    ssinq[1] = 0.f;
    ssinq[*npts + 1] = 0.f;
    return 0;
} /* rantst_ */

/* Subroutine */ int rantsb_(doublereal *a, doublereal *work, doublereal *ex, 
	integer *ifax, doublereal *ssini, doublereal *ssinq, integer *inc, 
	integer *jump, integer *npts, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, ia, it, iv, iv2, ivec, isym;
    extern /* Subroutine */ int fft991_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *);

/* *****-----------------****************************** */
/* transformation sinus reel basee sur temperton reel complex */
/* attention! ne marche que si  la dimension du champ>=npts+2 */
/* (comme pour temperton reel complexe) */
    /* Parameter adjustments */
    --ssinq;
    --ssini;
    --work;
    --a;

    /* Function Body */
    if (*isign == -1) {
	goto L1000;
    }
/* cas spectral --> physique */
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	iv2 = iv + *nft;
	ivec = (iv - 1) * *jump;
	ia = *inc + 1 + ivec;
	work[iv2] = a[ia];
	a[ia] = 0.f;
	a[ivec + 1] = work[iv2] * 2.f;
/* L10: */
    }
    ii1 = *npts - 1;
    for (ii = 3; ii <= ii1; ii += 2) {
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    ia = (ii - 1) * *inc + 1 + ivec;
	    work[iv] = a[ia];
	    a[ia] = a[ia + *inc] - work[iv2];
	    work[iv2] = a[ia + *inc];
	    a[ia + *inc] = -work[iv];
/* L11: */
	}
/* L100: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	iv2 = iv + *nft;
	ivec = (iv - 1) * *jump;
	a[*npts * *inc + ivec + 1] = work[iv2] * -2.f;
	a[(*npts + 1) * *inc + ivec + 1] = 0.f;
/* L12: */
    }

    fft991_(&a[1], &work[1], ex, ifax, inc, jump, npts, nft, isign);

/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[*npts * *inc + ivec + 1] = 0.f;
	a[ivec + 1] = 0.f;
/* L13: */
    }
    ii1 = *npts / 2;
    for (ii = 2; ii <= ii1; ++ii) {
	it = (ii - 1) * *inc + 1;
	isym = (*npts + 1 - ii) * *inc + 1;
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    work[iv] = (a[it + ivec] - a[isym + ivec]) * .5f;
	    work[iv2] = ssini[ii] * (a[it + ivec] + a[isym + ivec]);
	    a[it + ivec] = work[iv] + work[iv2];
	    a[isym + ivec] = -work[iv] + work[iv2];
/* L14: */
	}
/* L110: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[(*npts + 1) * *inc + ivec + 1] = 0.f;
	a[*inc * *npts / 2 + ivec + 1] *= .5f;
/* L15: */
    }
    return 0;
L1000:
/* cas physique --> spectral */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[ivec + 1] = 0.f;
/* L23: */
    }
    ii1 = *npts / 2;
    for (ii = 2; ii <= ii1; ++ii) {
	it = (ii - 1) * *inc + 1;
	isym = (*npts + 1 - ii) * *inc + 1;
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    work[iv] = (a[it + ivec] - a[isym + ivec]) * .5f;
	    work[iv2] = ssinq[ii] * (a[it + ivec] + a[isym + ivec]);
	    a[it + ivec] = work[iv] + work[iv2];
	    a[isym + ivec] = -work[iv] + work[iv2];
/* L24: */
	}
/* L210: */
    }
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	ia = *inc * *npts / 2 + ivec + 1;
	a[ia] *= 2.f;
/* L27: */
    }

    fft991_(&a[1], &work[1], ex, ifax, inc, jump, npts, nft, isign);

/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	iv2 = iv + *nft;
	ivec = (iv - 1) * *jump;
	ia = *inc + 1 + ivec;
	a[ia] = a[ivec + 1] * .5f;
	a[ivec + 1] = 0.f;
/* L20: */
    }
    ii1 = *npts - 1;
    for (ii = 3; ii <= ii1; ii += 2) {
/* DIR$ IVDEP */
	ii2 = *nft;
	for (iv = 1; iv <= ii2; ++iv) {
	    iv2 = iv + *nft;
	    ivec = (iv - 1) * *jump;
	    ia = (ii - 1) * *inc + 1 + ivec;
	    work[iv] = a[ia + *inc];
	    a[ia + *inc] = a[ia] + a[ia - *inc];
	    a[ia] = -work[iv];
/* L25: */
	}
/* L205: */
    }
/* DIR$ IVDEP */
    ii1 = *nft;
    for (iv = 1; iv <= ii1; ++iv) {
	ivec = (iv - 1) * *jump;
	a[*npts * *inc + ivec + 1] = 0.f;
	a[(*npts + 1) * *inc + ivec + 1] = 0.f;
/* L26: */
    }
    return 0;
} /* rantsb_ */

/* Subroutine */ int ftnorm_(doublereal *a, integer *n, integer *inc, integer 
	*jump, integer *nft, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2, ii3, ii4;

    /* Local variables */
    static doublereal f;
    static integer j, k;

/* *****-----------------*********** */
/* ?      real a(2,0:n) */
    /* Parameter adjustments */
    --a;

    /* Function Body */
    if (*isign == -1) {
	f = 1. / (doublereal) (*n);
	ii1 = *jump * (*nft - 1);
	ii2 = *jump;
	for (j = 0; ii2 < 0 ? j >= ii1 : j <= ii1; j += ii2) {
	    ii3 = j + (*n - 1) * *inc;
	    ii4 = *inc;
	    for (k = j; ii4 < 0 ? k >= ii3 : k <= ii3; k += ii4) {
		a[(k << 1) + 1] *= f;
/* L1: */
		a[(k << 1) + 2] *= f;
	    }
	}
    }
    return 0;
} /* ftnorm_ */

/* ***************************************************** */
/* now is the fortran source of  cray FFT991 and CFFT99 */
/* got from Ncar xmp 18-01-90 */
/* ***************************************************** */
/* Subroutine */ int fft99_(doublereal *a, doublereal *work, doublereal *
	trigs, integer *ifax, integer *inc, integer *jump, integer *n, 
	integer *lot, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, j, k, l, m, ia, ib, la, nh, nx, igo, ink, nfax, ibase,
	     jbase;
    extern /* Subroutine */ int fft99a_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *), 
	    fft99b_(doublereal *, doublereal *, doublereal *, integer *, 
	    integer *, integer *, integer *), vpassm_(doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, integer *,
	     integer *, integer *, integer *, integer *, integer *, integer *,
	     integer *);


/* PURPOSE      PERFORMS MULTIPLE FAST FOURIER TRANSFORMS.  THIS PACKAGE */
/*              WILL PERFORM A NUMBER OF SIMULTANEOUS REAL/HALF-COMPLEX */
/*              PERIODIC FOURIER TRANSFORMS OR CORRESPONDING INVERSE */
/*              TRANSFORMS, I.E.  GIVEN A SET OF REAL DATA VECTORS, THE */
/*              PACKAGE RETURNS A SET OF 'HALF-COMPLEX' FOURIER */
/*              COEFFICIENT VECTORS, OR VICE VERSA.  THE LENGTH OF THE */
/*              TRANSFORMS MUST BE AN EVEN NUMBER GREATER THAN 4 THAT HAS */
/*              NO OTHER FACTORS EXCEPT POSSIBLY POWERS OF 2, 3, AND 5. */
/*              THIS IS AN ALL FORTRAN VERSION OF THE CRAYLIB PACKAGE */
/*              THAT IS MOSTLY WRITTEN IN CAL. */

/*              THE PACKAGE FFT99F CONTAINS SEVERAL USER-LEVEL ROUTINES: */

/*            SUBROUTINE FFTFAX */
/*                AN INITIALIZATION ROUTINE THAT MUST BE CALLED ONCE */
/*                BEFORE A SEQUENCE OF CALLS TO THE FFT ROUTINES */
/*                (PROVIDED THAT N IS NOT CHANGED). */

/*            SUBROUTINES FFT99 AND FFT991 */
/*                TWO FFT ROUTINES THAT RETURN SLIGHTLY DIFFERENT */
/*                ARRANGEMENTS OF THE DATA IN GRIDPOINT SPACE. */


/* ACCESS       THIS FORTRAN VERSION MAY BE ACCESSED WITH */

/*                   *FORTRAN,P=XLIB,SN=FFT99F */

/*              TO ACCESS THE CRAY OBJECT CODE, CALLING THE USER ENTRY */
/*              POINTS FROM A CRAY PROGRAM IS SUFFICIENT.  THE SOURCE */
/*              FORTRAN AND CAL CODE FOR THE CRAYLIB VERSION MAY BE */
/*              ACCESSED USING */

/*                   FETCH P=CRAYLIB,SN=FFT99 */
/*                   FETCH P=CRAYLIB,SN=CAL99 */

/* USAGE        LET N BE OF THE FORM 2**P * 3**Q * 5**R, WHERE P .GE. 1, */
/*              Q .GE. 0, AND R .GE. 0.  THEN A TYPICAL SEQUENCE OF */
/*              CALLS TO TRANSFORM A GIVEN SET OF REAL VECTORS OF LENGTH */
/*              N TO A SET OF 'HALF-COMPLEX' FOURIER COEFFICIENT VECTORS */
/*              OF LENGTH N IS */

/*                   DIMENSION IFAX(13),TRIGS(3*N/2+1),A(M*(N+2)), */
/*                  +          WORK(M*(N+1)) */

/*                   CALL FFTFAX (N, IFAX, TRIGS) */
/*                   CALL FFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,M,ISIGN) */

/*              SEE THE INDIVIDUAL WRITE-UPS FOR FFTFAX, FFT99, AND */
/*              FFT991 BELOW, FOR A DETAILED DESCRIPTION OF THE */
/*              ARGUMENTS. */

/* HISTORY      THE PACKAGE WAS WRITTEN BY CLIVE TEMPERTON AT ECMWF IN */
/*              NOVEMBER, 1978.  IT WAS MODIFIED, DOCUMENTED, AND TESTED */
/*              FOR NCAR BY RUSS REW IN SEPTEMBER, 1980. */

/* ----------------------------------------------------------------------- */

/* SUBROUTINE FFTFAX (N,IFAX,TRIGS) */

/* PURPOSE      A SET-UP ROUTINE FOR FFT99 AND FFT991.  IT NEED ONLY BE */
/*              CALLED ONCE BEFORE A SEQUENCE OF CALLS TO THE FFT */
/*              ROUTINES (PROVIDED THAT N IS NOT CHANGED). */

/* ARGUMENT     IFAX(13),TRIGS(3*N/2+1) */
/* DIMENSIONS */

/* ARGUMENTS */

/* ON INPUT     N */
/*               AN EVEN NUMBER GREATER THAN 4 THAT HAS NO PRIME FACTOR */
/*               GREATER THAN 5.  N IS THE LENGTH OF THE TRANSFORMS (SEE */
/*               THE DOCUMENTATION FOR FFT99 AND FFT991 FOR THE */
/*               DEFINITIONS OF THE TRANSFORMS). */

/*              IFAX */
/*               AN INTEGER ARRAY.  THE NUMBER OF ELEMENTS ACTUALLY USED */
/*               WILL DEPEND ON THE FACTORIZATION OF N.  DIMENSIONING */
/*               IFAX FOR 13 SUFFICES FOR ALL N LESS THAN A MILLION. */

/*              TRIGS */
/*               A FLOATING POINT ARRAY OF DIMENSION 3*N/2 IF N/2 IS */
/*               EVEN, OR 3*N/2+1 IF N/2 IS ODD. */

/* ON OUTPUT    IFAX */
/*               CONTAINS THE FACTORIZATION OF N/2.  IFAX(1) IS THE */
/*               NUMBER OF FACTORS, AND THE FACTORS THEMSELVES ARE STORED */
/*               IN IFAX(2),IFAX(3),...  IF FFTFAX IS CALLED WITH N ODD, */
/*               OR IF N HAS ANY PRIME FACTORS GREATER THAN 5, IFAX(1) */
/*               IS SET TO -99. */

/*              TRIGS */
/*               AN ARRAY OF TRIGNOMENTRIC FUNCTION VALUES SUBSEQUENTLY */
/*               USED BY THE FFT ROUTINES. */

/* ----------------------------------------------------------------------- */

/* SUBROUTINE FFT991 (A,WORK,TRIGS,IFAX,INC,JUMP,N,M,ISIGN) */
/*                       AND */
/* SUBROUTINE FFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,M,ISIGN) */

/* PURPOSE      PERFORM A NUMBER OF SIMULTANEOUS REAL/HALF-COMPLEX */
/*              PERIODIC FOURIER TRANSFORMS OR CORRESPONDING INVERSE */
/*              TRANSFORMS, USING ORDINARY SPATIAL ORDER OF GRIDPOINT */
/*              VALUES (FFT991) OR EXPLICIT CYCLIC CONTINUITY IN THE */
/*              GRIDPOINT VALUES (FFT99).  GIVEN A SET */
/*              OF REAL DATA VECTORS, THE PACKAGE RETURNS A SET OF */
/*              'HALF-COMPLEX' FOURIER COEFFICIENT VECTORS, OR VICE */
/*              VERSA.  THE LENGTH OF THE TRANSFORMS MUST BE AN EVEN */
/*              NUMBER THAT HAS NO OTHER FACTORS EXCEPT POSSIBLY POWERS */
/*              OF 2, 3, AND 5.  THESE VERSION OF FFT991 AND FFT99 ARE */
/*              OPTIMIZED FOR USE ON THE CRAY-1. */

/* ARGUMENT     A(M*(N+2)), WORK(M*(N+1)), TRIGS(3*N/2+1), IFAX(13) */
/* DIMENSIONS */

/* ARGUMENTS */

/* ON INPUT     A */
/*               AN ARRAY OF LENGTH M*(N+2) CONTAINING THE INPUT DATA */
/*               OR COEFFICIENT VECTORS.  THIS ARRAY IS OVERWRITTEN BY */
/*               THE RESULTS. */

/*              WORK */
/*               A WORK ARRAY OF DIMENSION M*(N+1) */

/*              TRIGS */
/*               AN ARRAY SET UP BY FFTFAX, WHICH MUST BE CALLED FIRST. */

/*              IFAX */
/*               AN ARRAY SET UP BY FFTFAX, WHICH MUST BE CALLED FIRST. */

/*              INC */
/*               THE INCREMENT (IN WORDS) BETWEEN SUCCESSIVE ELEMENTS OF */
/*               EACH DATA OR COEFFICIENT VECTOR (E.G.  INC=1 FOR */
/*               CONSECUTIVELY STORED DATA). */

/*              JUMP */
/*               THE INCREMENT (IN WORDS) BETWEEN THE FIRST ELEMENTS OF */
/*               SUCCESSIVE DATA OR COEFFICIENT VECTORS.  ON THE CRAY-1, */
/*               TRY TO ARRANGE DATA SO THAT JUMP IS NOT A MULTIPLE OF 8 */
/*               (TO AVOID MEMORY BANK CONFLICTS).  FOR CLARIFICATION OF */
/*               INC AND JUMP, SEE THE EXAMPLES BELOW. */

/*              N */
/*               THE LENGTH OF EACH TRANSFORM (SEE DEFINITION OF */
/*               TRANSFORMS, BELOW). */

/*              M */
/*               THE NUMBER OF TRANSFORMS TO BE DONE SIMULTANEOUSLY. */

/*              ISIGN */
/*               = +1 FOR A TRANSFORM FROM FOURIER COEFFICIENTS TO */
/*                    GRIDPOINT VALUES. */
/*               = -1 FOR A TRANSFORM FROM GRIDPOINT VALUES TO FOURIER */
/*                    COEFFICIENTS. */

/* ON OUTPUT    A */
/*               IF ISIGN = +1, AND M COEFFICIENT VECTORS ARE SUPPLIED */
/*               EACH CONTAINING THE SEQUENCE: */

/*               A(0),B(0),A(1),B(1),...,A(N/2),B(N/2)  (N+2 VALUES) */

/*               THEN THE RESULT CONSISTS OF M DATA VECTORS EACH */
/*               CONTAINING THE CORRESPONDING N+2 GRIDPOINT VALUES: */

/*               FOR FFT991, X(0), X(1), X(2),...,X(N-1),0,0. */
/*               FOR FFT99, X(N-1),X(0),X(1),X(2),...,X(N-1),X(0). */
/*                   (EXPLICIT CYCLIC CONTINUITY) */

/*               WHEN ISIGN = +1, THE TRANSFORM IS DEFINED BY: */
/*                 X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N)) */
/*                 WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K) */
/*                 AND I=SQRT (-1) */

/*               IF ISIGN = -1, AND M DATA VECTORS ARE SUPPLIED EACH */
/*               CONTAINING A SEQUENCE OF GRIDPOINT VALUES X(J) AS */
/*               DEFINED ABOVE, THEN THE RESULT CONSISTS OF M VECTORS */
/*               EACH CONTAINING THE CORRESPONDING FOURIER COFFICIENTS */
/*               A(K), B(K), 0 .LE. K .LE N/2. */

/*               WHEN ISIGN = -1, THE INVERSE TRANSFORM IS DEFINED BY: */
/*                 C(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*EXP(-2*I*J*K*PI/N)) */
/*                 WHERE C(K)=A(K)+I*B(K) AND I=SQRT(-1) */

/*               A CALL WITH ISIGN=+1 FOLLOWED BY A CALL WITH ISIGN=-1 */
/*               (OR VICE VERSA) RETURNS THE ORIGINAL DATA. */

/*               NOTE: THE FACT THAT THE GRIDPOINT VALUES X(J) ARE REAL */
/*               IMPLIES THAT B(0)=B(N/2)=0.  FOR A CALL WITH ISIGN=+1, */
/*               IT IS NOT ACTUALLY NECESSARY TO SUPPLY THESE ZEROS. */

/* EXAMPLES      GIVEN 19 DATA VECTORS EACH OF LENGTH 64 (+2 FOR EXPLICIT */
/*               CYCLIC CONTINUITY), COMPUTE THE CORRESPONDING VECTORS OF */
/*               FOURIER COEFFICIENTS.  THE DATA MAY, FOR EXAMPLE, BE */
/*               ARRANGED LIKE THIS: */

/* FIRST DATA   A(1)=    . . .                A(66)=             A(70) */
/* VECTOR       X(63) X(0) X(1) X(2) ... X(63) X(0)  (4 EMPTY LOCATIONS) */

/* SECOND DATA  A(71)=   . . .                                  A(140) */
/* VECTOR       X(63) X(0) X(1) X(2) ... X(63) X(0)  (4 EMPTY LOCATIONS) */

/*               AND SO ON.  HERE INC=1, JUMP=70, N=64, M=19, ISIGN=-1, */
/*               AND FFT99 SHOULD BE USED (BECAUSE OF THE EXPLICIT CYCLIC */
/*               CONTINUITY). */

/*               ALTERNATIVELY THE DATA MAY BE ARRANGED LIKE THIS: */

/*                FIRST         SECOND                          LAST */
/*                DATA          DATA                            DATA */
/*                VECTOR        VECTOR                          VECTOR */

/*                 A(1)=         A(2)=                           A(19)= */

/*                 X(63)         X(63)       . . .               X(63) */
/*        A(20)=   X(0)          X(0)        . . .               X(0) */
/*        A(39)=   X(1)          X(1)        . . .               X(1) */
/*                  .             .                               . */
/*                  .             .                               . */
/*                  .             .                               . */

/*               IN WHICH CASE WE HAVE INC=19, JUMP=1, AND THE REMAINING */
/*               PARAMETERS ARE THE SAME AS BEFORE.  IN EITHER CASE, EACH */
/*               COEFFICIENT VECTOR OVERWRITES THE CORRESPONDING INPUT */
/*               DATA VECTOR. */

/* ----------------------------------------------------------------------- */

/*     SUBROUTINE "FFT99" - MULTIPLE FAST REAL PERIODIC TRANSFORM */
/*     CORRESPONDING TO OLD SCALAR ROUTINE FFT9 */
/*     PROCEDURE USED TO CONVERT TO HALF-LENGTH COMPLEX TRANSFORM */
/*     IS GIVEN BY COOLEY, LEWIS AND WELCH (J. SOUND VIB., VOL. 12 */
/*     (1970), 315-337) */

/*     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA */
/*     WORK IS AN AREA OF SIZE (N+1)*LOT */
/*     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES */
/*     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N/2 */
/*     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR' */
/*         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA) */
/*     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR */
/*     N IS THE LENGTH OF THE DATA VECTORS */
/*     LOT IS THE NUMBER OF DATA VECTORS */
/*     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT */
/*           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL */

/*     ORDERING OF COEFFICIENTS: */
/*         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2) */
/*         WHERE B(0)=B(N/2)=0; (N+2) LOCATIONS REQUIRED */

/*     ORDERING OF DATA: */
/*         X(N-1),X(0),X(1),X(2),...,X(N),X(0) */
/*         I.E. EXPLICIT CYCLIC CONTINUITY; (N+2) LOCATIONS REQUIRED */

/*     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN */
/*     PARALLEL */

/*     *** N.B. N IS ASSUMED TO BE AN EVEN NUMBER */

/*     DEFINITION OF TRANSFORMS: */
/*     ------------------------- */

/*     ISIGN=+1: X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N)) */
/*         WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K) */

/*     ISIGN=-1: A(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N)) */
/*               B(K)=-(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N)) */




    /* Parameter adjustments */
    --ifax;
    --trigs;
    --work;
    --a;

    /* Function Body */
    nfax = ifax[1];
    nx = *n + 1;
    nh = *n / 2;
    ink = *inc + *inc;
    if (*isign == 1) {
	goto L30;
    }

/*     IF NECESSARY, TRANSFER DATA TO WORK AREA */
    igo = 50;
    if (nfax % 2 == 1) {
	goto L40;
    }
    ibase = *inc + 1;
    jbase = 1;
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii2 = *n;
	for (m = 1; m <= ii2; ++m) {
	    work[j] = a[ii];
	    ii += *inc;
	    ++j;
/* L10: */
	}
	ibase += *jump;
	jbase += nx;
/* L20: */
    }

    igo = 60;
    goto L40;

/*     PREPROCESSING (ISIGN=+1) */
/*     ------------------------ */

L30:
    fft99a_(&a[1], &work[1], &trigs[1], inc, jump, n, lot);
    igo = 60;

/*     COMPLEX TRANSFORM */
/*     ----------------- */

L40:
    ia = *inc + 1;
    la = 1;
    ii1 = nfax;
    for (k = 1; k <= ii1; ++k) {
	if (igo == 60) {
	    goto L60;
	}
/* L50: */
	vpassm_(&a[ia], &a[ia + *inc], &work[1], &work[2], &trigs[1], &ink, &
		c2, jump, &nx, lot, &nh, &ifax[k + 1], &la);
	igo = 60;
	goto L70;
L60:
	vpassm_(&work[1], &work[2], &a[ia], &a[ia + *inc], &trigs[1], &c2, &
		ink, &nx, jump, lot, &nh, &ifax[k + 1], &la);
	igo = 50;
L70:
	la *= ifax[k + 1];
/* L80: */
    }

    if (*isign == -1) {
	goto L130;
    }

/*     IF NECESSARY, TRANSFER DATA FROM WORK AREA */
    if (nfax % 2 == 1) {
	goto L110;
    }
    ibase = 1;
    jbase = ia;
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii2 = *n;
	for (m = 1; m <= ii2; ++m) {
	    a[j] = work[ii];
	    ++ii;
	    j += *inc;
/* L90: */
	}
	ibase += nx;
	jbase += *jump;
/* L100: */
    }

/*     FILL IN CYCLIC BOUNDARY POINTS */
L110:
    ia = 1;
    ib = *n * *inc + 1;
/* DIR$ IVDEP */
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	a[ia] = a[ib];
	a[ib + *inc] = a[ia + *inc];
	ia += *jump;
	ib += *jump;
/* L120: */
    }
    goto L140;

/*     POSTPROCESSING (ISIGN=-1): */
/*     -------------------------- */

L130:
    fft99b_(&work[1], &a[1], &trigs[1], inc, jump, n, lot);

L140:
    return 0;
} /* fft99_ */

/* Subroutine */ int fft99a_(doublereal *a, doublereal *work, doublereal *
	trigs, integer *inc, integer *jump, integer *n, integer *lot)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static doublereal c;
    static integer k, l;
    static doublereal s;
    static integer ia, ib, ja, jb, nh, nx, ink, iabase, ibbase, jabase, 
	    jbbase;


/*     SUBROUTINE FFT99A - PREPROCESSING STEP FOR FFT99, ISIGN=+1 */
/*     (SPECTRAL TO GRIDPOINT TRANSFORM) */

    /* Parameter adjustments */
    --trigs;
    --work;
    --a;

    /* Function Body */
    nh = *n / 2;
    nx = *n + 1;
    ink = *inc + *inc;

/*     A(0) AND A(N/2) */
    ia = 1;
    ib = *n * *inc + 1;
    ja = 1;
    jb = 2;
/* DIR$ IVDEP */
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	work[ja] = a[ia] + a[ib];
	work[jb] = a[ia] - a[ib];
	ia += *jump;
	ib += *jump;
	ja += nx;
	jb += nx;
/* L10: */
    }

/*     REMAINING WAVENUMBERS */
    iabase = (*inc << 1) + 1;
    ibbase = (*n - 2) * *inc + 1;
    jabase = 3;
    jbbase = *n - 1;

    ii1 = nh;
    for (k = 3; k <= ii1; k += 2) {
	ia = iabase;
	ib = ibbase;
	ja = jabase;
	jb = jbbase;
	c = trigs[*n + k];
	s = trigs[*n + k + 1];
/* DIR$ IVDEP */
	ii2 = *lot;
	for (l = 1; l <= ii2; ++l) {
	    work[ja] = a[ia] + a[ib] - (s * (a[ia] - a[ib]) + c * (a[ia + *
		    inc] + a[ib + *inc]));
	    work[jb] = a[ia] + a[ib] + (s * (a[ia] - a[ib]) + c * (a[ia + *
		    inc] + a[ib + *inc]));
	    work[ja + 1] = c * (a[ia] - a[ib]) - s * (a[ia + *inc] + a[ib + 
		    *inc]) + (a[ia + *inc] - a[ib + *inc]);
	    work[jb + 1] = c * (a[ia] - a[ib]) - s * (a[ia + *inc] + a[ib + 
		    *inc]) - (a[ia + *inc] - a[ib + *inc]);
	    ia += *jump;
	    ib += *jump;
	    ja += nx;
	    jb += nx;
/* L20: */
	}
	iabase += ink;
	ibbase -= ink;
	jabase += 2;
	jbbase += -2;
/* L30: */
    }

    if (iabase != ibbase) {
	goto L50;
    }
/*     WAVENUMBER N/4 (IF IT EXISTS) */
    ia = iabase;
    ja = jabase;
/* DIR$ IVDEP */
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	work[ja] = a[ia] * 2.;
	work[ja + 1] = a[ia + *inc] * -2.;
	ia += *jump;
	ja += nx;
/* L40: */
    }

L50:
    return 0;
} /* fft99a_ */

/* Subroutine */ int fft99b_(doublereal *work, doublereal *a, doublereal *
	trigs, integer *inc, integer *jump, integer *n, integer *lot)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static doublereal c;
    static integer k, l;
    static doublereal s;
    static integer ia, ib, ja, jb, nh, nx, ink;
    static doublereal scale;
    static integer iabase, ibbase, jabase, jbbase;


/*     SUBROUTINE FFT99B - POSTPROCESSING STEP FOR FFT99, ISIGN=-1 */
/*     (GRIDPOINT TO SPECTRAL TRANSFORM) */

    /* Parameter adjustments */
    --trigs;
    --a;
    --work;

    /* Function Body */
    nh = *n / 2;
    nx = *n + 1;
    ink = *inc + *inc;

/*     A(0) AND A(N/2) */
    scale = 1. / (doublereal) (*n);
    ia = 1;
    ib = 2;
    ja = 1;
    jb = *n * *inc + 1;
/* DIR$ IVDEP */
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	a[ja] = scale * (work[ia] + work[ib]);
	a[jb] = scale * (work[ia] - work[ib]);
	a[ja + *inc] = 0.;
	a[jb + *inc] = 0.;
	ia += nx;
	ib += nx;
	ja += *jump;
	jb += *jump;
/* L10: */
    }

/*     REMAINING WAVENUMBERS */
    scale *= .5;
    iabase = 3;
    ibbase = *n - 1;
    jabase = (*inc << 1) + 1;
    jbbase = (*n - 2) * *inc + 1;

    ii1 = nh;
    for (k = 3; k <= ii1; k += 2) {
	ia = iabase;
	ib = ibbase;
	ja = jabase;
	jb = jbbase;
	c = trigs[*n + k];
	s = trigs[*n + k + 1];
/* DIR$ IVDEP */
	ii2 = *lot;
	for (l = 1; l <= ii2; ++l) {
	    a[ja] = scale * (work[ia] + work[ib] + (c * (work[ia + 1] + 
		    work[ib + 1]) + s * (work[ia] - work[ib])));
	    a[jb] = scale * (work[ia] + work[ib] - (c * (work[ia + 1] + 
		    work[ib + 1]) + s * (work[ia] - work[ib])));
	    a[ja + *inc] = scale * (c * (work[ia] - work[ib]) - s * (work[
		    ia + 1] + work[ib + 1]) + (work[ib + 1] - work[ia + 1]));
	    a[jb + *inc] = scale * (c * (work[ia] - work[ib]) - s * (work[
		    ia + 1] + work[ib + 1]) - (work[ib + 1] - work[ia + 1]));
	    ia += nx;
	    ib += nx;
	    ja += *jump;
	    jb += *jump;
/* L20: */
	}
	iabase += 2;
	ibbase += -2;
	jabase += ink;
	jbbase -= ink;
/* L30: */
    }

    if (iabase != ibbase) {
	goto L50;
    }
/*     WAVENUMBER N/4 (IF IT EXISTS) */
    ia = iabase;
    ja = jabase;
    scale *= 2.;
/* DIR$ IVDEP */
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	a[ja] = scale * work[ia];
	a[ja + *inc] = -scale * work[ia + 1];
	ia += nx;
	ja += *jump;
/* L40: */
    }

L50:
    return 0;
} /* fft99b_ */

/* Subroutine */ int fft991_(doublereal *a, doublereal *work, doublereal *
	trigs, integer *ifax, integer *inc, integer *jump, integer *n, 
	integer *lot, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, j, k, l, m, ia, ib, la, nh, nx, igo, ink, nfax, ibase,
	     jbase;
    extern /* Subroutine */ int fft99a_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *), 
	    fft99b_(doublereal *, doublereal *, doublereal *, integer *, 
	    integer *, integer *, integer *), vpassm_(doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, integer *,
	     integer *, integer *, integer *, integer *, integer *, integer *,
	     integer *);


/*     SUBROUTINE "FFT991" - MULTIPLE REAL/HALF-COMPLEX PERIODIC */
/*     FAST FOURIER TRANSFORM */

/*     SAME AS FFT99 EXCEPT THAT ORDERING OF DATA CORRESPONDS TO */
/*     THAT IN MRFFT2 */

/*     PROCEDURE USED TO CONVERT TO HALF-LENGTH COMPLEX TRANSFORM */
/*     IS GIVEN BY COOLEY, LEWIS AND WELCH (J. SOUND VIB., VOL. 12 */
/*     (1970), 315-337) */

/*     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA */
/*     WORK IS AN AREA OF SIZE (N+1)*LOT */
/*     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES */
/*     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N/2 */
/*     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR' */
/*         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA) */
/*     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR */
/*     N IS THE LENGTH OF THE DATA VECTORS */
/*     LOT IS THE NUMBER OF DATA VECTORS */
/*     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT */
/*           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL */

/*     ORDERING OF COEFFICIENTS: */
/*         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2) */
/*         WHERE B(0)=B(N/2)=0; (N+2) LOCATIONS REQUIRED */

/*     ORDERING OF DATA: */
/*         X(0),X(1),X(2),...,X(N-1) */

/*     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN */
/*     PARALLEL */

/*     *** N.B. N IS ASSUMED TO BE AN EVEN NUMBER */

/*     DEFINITION OF TRANSFORMS: */
/*     ------------------------- */

/*     ISIGN=+1: X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N)) */
/*         WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K) */

/*     ISIGN=-1: A(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N)) */
/*               B(K)=-(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N)) */



    /* Parameter adjustments */
    --ifax;
    --trigs;
    --work;
    --a;

    /* Function Body */
    nfax = ifax[1];
    nx = *n + 1;
    nh = *n / 2;
    ink = *inc + *inc;
    if (*isign == 1) {
	goto L30;
    }

/*     IF NECESSARY, TRANSFER DATA TO WORK AREA */
    igo = 50;
    if (nfax % 2 == 1) {
	goto L40;
    }
    ibase = 1;
    jbase = 1;
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii2 = *n;
	for (m = 1; m <= ii2; ++m) {
	    work[j] = a[ii];
	    ii += *inc;
	    ++j;
/* L10: */
	}
	ibase += *jump;
	jbase += nx;
/* L20: */
    }

    igo = 60;
    goto L40;

/*     PREPROCESSING (ISIGN=+1) */
/*     ------------------------ */

L30:
    fft99a_(&a[1], &work[1], &trigs[1], inc, jump, n, lot);
    igo = 60;

/*     COMPLEX TRANSFORM */
/*     ----------------- */

L40:
    ia = 1;
    la = 1;
    ii1 = nfax;
    for (k = 1; k <= ii1; ++k) {
	if (igo == 60) {
	    goto L60;
	}
/* L50: */
	vpassm_(&a[ia], &a[ia + *inc], &work[1], &work[2], &trigs[1], &ink, &
		c2, jump, &nx, lot, &nh, &ifax[k + 1], &la);
	igo = 60;
	goto L70;
L60:
	vpassm_(&work[1], &work[2], &a[ia], &a[ia + *inc], &trigs[1], &c2, &
		ink, &nx, jump, lot, &nh, &ifax[k + 1], &la);
	igo = 50;
L70:
	la *= ifax[k + 1];
/* L80: */
    }

    if (*isign == -1) {
	goto L130;
    }

/*     IF NECESSARY, TRANSFER DATA FROM WORK AREA */
    if (nfax % 2 == 1) {
	goto L110;
    }
    ibase = 1;
    jbase = 1;
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii2 = *n;
	for (m = 1; m <= ii2; ++m) {
	    a[j] = work[ii];
	    ++ii;
	    j += *inc;
/* L90: */
	}
	ibase += nx;
	jbase += *jump;
/* L100: */
    }

/*     FILL IN ZEROS AT END */
L110:
    ib = *n * *inc + 1;
/* DIR$ IVDEP */
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	a[ib] = 0.;
	a[ib + *inc] = 0.;
	ib += *jump;
/* L120: */
    }
    goto L140;

/*     POSTPROCESSING (ISIGN=-1): */
/*     -------------------------- */

L130:
    fft99b_(&work[1], &a[1], &trigs[1], inc, jump, n, lot);

L140:
    return 0;
} /* fft991_ */

/* Subroutine */ int fftfax_(integer *n, integer *ifax, doublereal *trigs)
{
    /* Initialized data */

    static integer mode = 3;

    static integer ii;
    extern /* Subroutine */ int fax_(integer *, integer *, integer *), 
	    fftrig_(doublereal *, integer *, integer *), uliber_(void);


/* MODE 3 IS USED FOR REAL/HALF-COMPLEX TRANSFORMS.  IT IS POSSIBLE */
/* TO DO COMPLEX/COMPLEX TRANSFORMS WITH OTHER VALUES OF MODE, BUT */
/* DOCUMENTATION OF THE DETAILS WERE NOT AVAILABLE WHEN THIS ROUTINE */
/* WAS WRITTEN. */

    /* Parameter adjustments */
    --trigs;
    --ifax;

    /* Function Body */
    fax_(&ifax[1], n, &mode);
    ii = ifax[1];
    if (ifax[ii + 1] > 5 || *n <= 4) {
	ifax[1] = -99;
    }
    if (ifax[1] <= 0) {
	uliber_();
    }
    fftrig_(&trigs[1], n, &mode);
    return 0;
} /* fftfax_ */

/* Subroutine */ int fax_(integer *ifax, integer *n, integer *mode)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, k, l, nn, inc, nfax, item, istop;

    /* Parameter adjustments */
    --ifax;

    /* Function Body */
    nn = *n;
    if (abs(*mode) == 1) {
	goto L10;
    }
    if (abs(*mode) == 8) {
	goto L10;
    }
    nn = *n / 2;
    if (nn + nn == *n) {
	goto L10;
    }
    ifax[1] = -99;
    return 0;
L10:
    k = 1;
/*     TEST FOR FACTORS OF 4 */
L20:
    if (nn % 4 != 0) {
	goto L30;
    }
    ++k;
    ifax[k] = 4;
    nn /= 4;
    if (nn == 1) {
	goto L80;
    }
    goto L20;
/*     TEST FOR EXTRA FACTOR OF 2 */
L30:
    if (nn % 2 != 0) {
	goto L40;
    }
    ++k;
    ifax[k] = 2;
    nn /= 2;
    if (nn == 1) {
	goto L80;
    }
/*     TEST FOR FACTORS OF 3 */
L40:
    if (nn % 3 != 0) {
	goto L50;
    }
    ++k;
    ifax[k] = 3;
    nn /= 3;
    if (nn == 1) {
	goto L80;
    }
    goto L40;
/*     NOW FIND REMAINING FACTORS */
L50:
    l = 5;
    inc = 2;
/*     INC ALTERNATELY TAKES ON VALUES 2 AND 4 */
L60:
    if (nn % l != 0) {
	goto L70;
    }
    ++k;
    ifax[k] = l;
    nn /= l;
    if (nn == 1) {
	goto L80;
    }
    goto L60;
L70:
    l += inc;
    inc = 6 - inc;
    goto L60;
L80:
    ifax[1] = k - 1;
/*     IFAX(1) CONTAINS NUMBER OF FACTORS */
    nfax = ifax[1];
/*     SORT FACTORS INTO ASCENDING ORDER */
    if (nfax == 1) {
	goto L110;
    }
    ii1 = nfax;
    for (ii = 2; ii <= ii1; ++ii) {
	istop = nfax + 2 - ii;
	ii2 = istop;
	for (ii = 2; ii <= ii2; ++ii) {
	    if (ifax[ii + 1] >= ifax[ii]) {
		goto L90;
	    }
	    item = ifax[ii];
	    ifax[ii] = ifax[ii + 1];
	    ifax[ii + 1] = item;
L90:
	    ;
	}
/* L100: */
    }
L110:
    return 0;
} /* fax_ */

/* Subroutine */ int fftrig_(doublereal *trigs, integer *n, integer *mode)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double asin(doublereal), cos(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii, l, la, nh;
    static doublereal pi;
    static integer nn;
    static doublereal del, angle;
    static integer imode;

    /* Parameter adjustments */
    --trigs;

    /* Function Body */
    pi = asin(1.) * 2.;
    imode = abs(*mode);
    nn = *n;
    if (imode > 1 && imode < 6) {
	nn = *n / 2;
    }
    del = (pi + pi) / (real) nn;
    l = nn + nn;
    ii1 = l;
    for (ii = 1; ii <= ii1; ii += 2) {
	angle = (doublereal) (ii - 1) * .5 * del;
	trigs[ii] = cos(angle);
	trigs[ii + 1] = sin(angle);
/* L10: */
    }
    if (imode == 1) {
	return 0;
    }
    if (imode == 8) {
	return 0;
    }
    del *= .5;
    nh = (nn + 1) / 2;
    l = nh + nh;
    la = nn + nn;
    ii1 = l;
    for (ii = 1; ii <= ii1; ii += 2) {
	angle = (doublereal) (ii - 1) * .5 * del;
	trigs[la + ii] = cos(angle);
	trigs[la + ii + 1] = sin(angle);
/* L20: */
    }
    if (imode <= 3) {
	return 0;
    }
    del *= .5;
    la += nn;
    if (*mode == 5) {
	goto L40;
    }
    ii1 = nn;
    for (ii = 2; ii <= ii1; ++ii) {
	angle = (doublereal) (ii - 1) * del;
	trigs[la + ii] = sin(angle) * 2.;
/* L30: */
    }
    return 0;
L40:
    del *= .5;
    ii1 = *n;
    for (ii = 2; ii <= ii1; ++ii) {
	angle = (doublereal) (ii - 1) * del;
	trigs[la + ii] = sin(angle);
/* L50: */
    }
    return 0;
} /* fftrig_ */

/* Subroutine */ int cfft99_(doublereal *a, doublereal *work, doublereal *
	trigs, integer *ifax, integer *inc, integer *jump, integer *n, 
	integer *lot, integer *isign)
{
    /* System generated locals */
    integer ii1, ii2;

    /* Local variables */
    static integer ii, j, k, l, m, i1, i2, la, nh, nn, igo, ink, jnk, jum, 
	    jst, nfax, ibase, jbase;
    static doublereal himag, hreal;
    static integer ilast;
    extern /* Subroutine */ int vpassm_(doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, integer *, integer *, 
	    integer *, integer *, integer *, integer *, integer *, integer *);


/* PURPOSE      PERFORMS MULTIPLE FAST FOURIER TRANSFORMS.  THIS PACKAGE */
/*              WILL PERFORM A NUMBER OF SIMULTANEOUS COMPLEX PERIODIC */
/*              FOURIER TRANSFORMS OR CORRESPONDING INVERSE TRANSFORMS. */
/*              THAT IS, GIVEN A SET OF COMPLEX GRIDPOINT VECTORS, THE */
/*              PACKAGE RETURNS A SET OF COMPLEX FOURIER */
/*              COEFFICIENT VECTORS, OR VICE VERSA.  THE LENGTH OF THE */
/*              TRANSFORMS MUST BE A NUMBER GREATER THAN 1 THAT HAS */
/*              NO PRIME FACTORS OTHER THAN 2, 3, AND 5. */

/*              THE PACKAGE CFFT99 CONTAINS SEVERAL USER-LEVEL ROUTINES: */

/*            SUBROUTINE CFTFAX */
/*                AN INITIALIZATION ROUTINE THAT MUST BE CALLED ONCE */
/*                BEFORE A SEQUENCE OF CALLS TO CFFT99 */
/*                (PROVIDED THAT N IS NOT CHANGED). */

/*            SUBROUTINE CFFT99 */
/*                THE ACTUAL TRANSFORM ROUTINE ROUTINE, CABABLE OF */
/*                PERFORMING BOTH THE TRANSFORM AND ITS INVERSE. */
/*                HOWEVER, AS THE TRANSFORMS ARE NOT NORMALIZED, */
/*                THE APPLICATION OF A TRANSFORM FOLLOWED BY ITS */
/*                INVERSE WILL YIELD THE ORIGINAL VALUES MULTIPLIED */
/*                BY N. */


/* ACCESS       *FORTRAN,P=XLIB,SN=CFFT99 */


/* USAGE        LET N BE OF THE FORM 2**P * 3**Q * 5**R, WHERE P .GE. 0, */
/*              Q .GE. 0, AND R .GE. 0.  THEN A TYPICAL SEQUENCE OF */
/*              CALLS TO TRANSFORM A GIVEN SET OF COMPLEX VECTORS OF */
/*              LENGTH N TO A SET OF (UNSCALED) COMPLEX FOURIER */
/*              COEFFICIENT VECTORS OF LENGTH N IS */

/*                   DIMENSION IFAX(13),TRIGS(2*N) */
/*                   COMPLEX A(...), WORK(...) */

/*                   CALL CFTFAX (N, IFAX, TRIGS) */
/*                   CALL CFFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN) */

/*              THE OUTPUT VECTORS OVERWRITE THE INPUT VECTORS, AND */
/*              THESE ARE STORED IN A.  WITH APPROPRIATE CHOICES FOR */
/*              THE OTHER ARGUMENTS, THESE VECTORS MAY BE CONSIDERED */
/*              EITHER THE ROWS OR THE COLUMNS OF THE ARRAY A. */
/*              SEE THE INDIVIDUAL WRITE-UPS FOR CFTFAX AND */
/*              CFFT99 BELOW, FOR A DETAILED DESCRIPTION OF THE */
/*              ARGUMENTS. */

/* HISTORY      THE PACKAGE WAS WRITTEN BY CLIVE TEMPERTON AT ECMWF IN */
/*              NOVEMBER, 1978.  IT WAS MODIFIED, DOCUMENTED, AND TESTED */
/*              FOR NCAR BY RUSS REW IN SEPTEMBER, 1980.  IT WAS */
/*              FURTHER MODIFIED FOR THE FULLY COMPLEX CASE BY DAVE */
/*              FULKER IN NOVEMBER, 1980. */

/* ----------------------------------------------------------------------- */

/* SUBROUTINE CFTFAX (N,IFAX,TRIGS) */

/* PURPOSE      A SET-UP ROUTINE FOR CFFT99.  IT NEED ONLY BE */
/*              CALLED ONCE BEFORE A SEQUENCE OF CALLS TO CFFT99, */
/*              PROVIDED THAT N IS NOT CHANGED. */

/* ARGUMENT     IFAX(13),TRIGS(2*N) */
/* DIMENSIONS */

/* ARGUMENTS */

/* ON INPUT     N */
/*               AN EVEN NUMBER GREATER THAN 1 THAT HAS NO PRIME FACTOR */
/*               GREATER THAN 5.  N IS THE LENGTH OF THE TRANSFORMS (SEE */
/*               THE DOCUMENTATION FOR CFFT99 FOR THE DEFINITION OF */
/*               THE TRANSFORMS). */

/*              IFAX */
/*               AN INTEGER ARRAY.  THE NUMBER OF ELEMENTS ACTUALLY USED */
/*               WILL DEPEND ON THE FACTORIZATION OF N.  DIMENSIONING */
/*               IFAX FOR 13 SUFFICES FOR ALL N LESS THAN 1 MILLION. */

/*              TRIGS */
/*               A REAL ARRAY OF DIMENSION 2*N */

/* ON OUTPUT    IFAX */
/*               CONTAINS THE FACTORIZATION OF N.  IFAX(1) IS THE */
/*               NUMBER OF FACTORS, AND THE FACTORS THEMSELVES ARE STORED */
/*               IN IFAX(2),IFAX(3),...  IF N HAS ANY PRIME FACTORS */
/*               GREATER THAN 5, IFAX(1) IS SET TO -99. */

/*              TRIGS */
/*               AN ARRAY OF TRIGONOMETRIC FUNCTION VALUES SUBSEQUENTLY */
/*               USED BY THE CFT ROUTINES. */

/* ----------------------------------------------------------------------- */

/* SUBROUTINE CFFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN) */

/* PURPOSE      PERFORM A NUMBER OF SIMULTANEOUS (UNNORMALIZED) COMPLEX */
/*              PERIODIC FOURIER TRANSFORMS OR CORRESPONDING INVERSE */
/*              TRANSFORMS.  GIVEN A SET OF COMPLEX GRIDPOINT */
/*              VECTORS, THE PACKAGE RETURNS A SET OF */
/*              COMPLEX FOURIER COEFFICIENT VECTORS, OR VICE */
/*              VERSA.  THE LENGTH OF THE TRANSFORMS MUST BE A */
/*              NUMBER HAVING NO PRIME FACTORS OTHER THAN */
/*              2, 3, AND 5.  THIS ROUTINE IS */
/*              OPTIMIZED FOR USE ON THE CRAY-1. */

/* ARGUMENT     COMPLEX A(N*INC+(LOT-1)*JUMP), WORK(N*LOT) */
/* DIMENSIONS   REAL TRIGS(2*N), INTEGER IFAX(13) */

/* ARGUMENTS */

/* ON INPUT     A */
/*               A COMPLEX ARRAY OF LENGTH N*INC+(LOT-1)*JUMP CONTAINING */
/*               THE INPUT GRIDPOINT OR COEFFICIENT VECTORS.  THIS ARRAY */
/*               OVERWRITTEN BY THE RESULTS. */

/*               N.B. ALTHOUGH THE ARRAY A IS USUALLY CONSIDERED TO BE OF */
/*               TYPE COMPLEX IN THE CALLING PROGRAM, IT IS TREATED AS */
/*               REAL WITHIN THE TRANSFORM PACKAGE.  THIS REQUIRES THAT */
/*               SUCH TYPE CONFLICTS ARE PERMITTED IN THE USER"S */
/*               ENVIRONMENT, AND THAT THE STORAGE OF COMPLEX NUMBERS */
/*               MATCHES THE ASSUMPTIONS OF THIS ROUTINE.  THIS ROUTINE */
/*               ASSUMES THAT THE REAL AND IMAGINARY PORTIONS OF A */
/*               COMPLEX NUMBER OCCUPY ADJACENT ELEMENTS OF MEMORY.  IF */
/*               THESE CONDITIONS ARE NOT MET, THE USER MUST TREAT THE */
/*               ARRAY A AS REAL (AND OF TWICE THE ABOVE LENGTH), AND */
/*               WRITE THE CALLING PROGRAM TO TREAT THE REAL AND */
/*               IMAGINARY PORTIONS EXPLICITLY. */

/*              WORK */
/*               A COMPLEX WORK ARRAY OF LENGTH N*LOT OR A REAL ARRAY */
/*               OF LENGTH 2*N*LOT.  SEE N.B. ABOVE. */

/*              TRIGS */
/*               AN ARRAY SET UP BY CFTFAX, WHICH MUST BE CALLED FIRST. */

/*              IFAX */
/*               AN ARRAY SET UP BY CFTFAX, WHICH MUST BE CALLED FIRST. */


/*               N.B. IN THE FOLLOWING ARGUMENTS, INCREMENTS ARE MEASURED */
/*               IN WORD PAIRS, BECAUSE EACH COMPLEX ELEMENT IS ASSUMED */
/*               TO OCCUPY AN ADJACENT PAIR OF WORDS IN MEMORY. */

/*              INC */
/*               THE INCREMENT (IN WORD PAIRS) BETWEEN SUCCESSIVE ELEMENT */
/*               OF EACH (COMPLEX) GRIDPOINT OR COEFFICIENT VECTOR */
/*               (E.G.  INC=1 FOR CONSECUTIVELY STORED DATA). */

/*              JUMP */
/*               THE INCREMENT (IN WORD PAIRS) BETWEEN THE FIRST ELEMENTS */
/*               OF SUCCESSIVE DATA OR COEFFICIENT VECTORS.  ON THE CRAY- */
/*               TRY TO ARRANGE DATA SO THAT JUMP IS NOT A MULTIPLE OF 8 */
/*               (TO AVOID MEMORY BANK CONFLICTS).  FOR CLARIFICATION OF */
/*               INC AND JUMP, SEE THE EXAMPLES BELOW. */

/*              N */
/*               THE LENGTH OF EACH TRANSFORM (SEE DEFINITION OF */
/*               TRANSFORMS, BELOW). */

/*              LOT */
/*               THE NUMBER OF TRANSFORMS TO BE DONE SIMULTANEOUSLY. */

/*              ISIGN */
/*               = -1 FOR A TRANSFORM FROM GRIDPOINT VALUES TO FOURIER */
/*                    COEFFICIENTS. */
/*               = +1 FOR A TRANSFORM FROM FOURIER COEFFICIENTS TO */
/*                    GRIDPOINT VALUES. */

/* ON OUTPUT    A */
/*               IF ISIGN = -1, AND LOT GRIDPOINT VECTORS ARE SUPPLIED, */
/*               EACH CONTAINING THE COMPLEX SEQUENCE: */

/*               G(0),G(1), ... ,G(N-1)  (N COMPLEX VALUES) */

/*               THEN THE RESULT CONSISTS OF LOT COMPLEX VECTORS EACH */
/*               CONTAINING THE CORRESPONDING N COEFFICIENT VALUES: */

/*               C(0),C(1), ... ,C(N-1)  (N COMPLEX VALUES) */

/*               DEFINED BY: */
/*                 C(K) = SUM(J=0,...,N-1)( G(J)*EXP(-2*I*J*K*PI/N) ) */
/*                 WHERE I = SQRT(-1) */


/*               IF ISIGN = +1, AND LOT COEFFICIENT VECTORS ARE SUPPLIED, */
/*               EACH CONTAINING THE COMPLEX SEQUENCE: */

/*               C(0),C(1), ... ,C(N-1)  (N COMPLEX VALUES) */

/*               THEN THE RESULT CONSISTS OF LOT COMPLEX VECTORS EACH */
/*               CONTAINING THE CORRESPONDING N GRIDPOINT VALUES: */

/*               G(0),G(1), ... ,G(N-1)  (N COMPLEX VALUES) */

/*               DEFINED BY: */
/*                 G(J) = SUM(K=0,...,N-1)( G(K)*EXP(+2*I*J*K*PI/N) ) */
/*                 WHERE I = SQRT(-1) */


/*               A CALL WITH ISIGN=-1 FOLLOWED BY A CALL WITH ISIGN=+1 */
/*               (OR VICE VERSA) RETURNS THE ORIGINAL DATA, MULTIPLIED */
/*               BY THE FACTOR N. */


/* EXAMPLE       GIVEN A 64 BY 9 GRID OF COMPLEX VALUES, STORED IN */
/*               A 66 BY 9 COMPLEX ARRAY, A, COMPUTE THE TWO DIMENSIONAL */
/*               FOURIER TRANSFORM OF THE GRID.  FROM TRANSFORM THEORY, */
/*               IT IS KNOWN THAT A TWO DIMENSIONAL TRANSFORM CAN BE */
/*               OBTAINED BY FIRST TRANSFORMING THE GRID ALONG ONE */
/*               DIRECTION, THEN TRANSFORMING THESE RESULTS ALONG THE */
/*               ORTHOGONAL DIRECTION. */

/*               COMPLEX A(66,9), WORK(64,9) */
/*               REAL TRIGS1(128), TRIGS2(18) */
/*               INTEGER IFAX1(13), IFAX2(13) */

/*               SET UP THE IFAX AND TRIGS ARRAYS FOR EACH DIRECTION: */

/*               CALL CFTFAX(64, IFAX1, TRIGS1) */
/*               CALL CFTFAX( 9, IFAX2, TRIGS2) */

/*               IN THIS CASE, THE COMPLEX VALUES OF THE GRID ARE */
/*               STORED IN MEMORY AS FOLLOWS (USING U AND V TO */
/*               DENOTE THE REAL AND IMAGINARY COMPONENTS, AND */
/*               ASSUMING CONVENTIONAL FORTRAN STORAGE): */

/*   U(1,1), V(1,1), U(2,1), V(2,1),  ...  U(64,1), V(64,1), 4 NULLS, */

/*   U(1,2), V(1,2), U(2,2), V(2,2),  ...  U(64,2), V(64,2), 4 NULLS, */

/*   .       .       .       .         .   .        .        . */
/*   .       .       .       .         .   .        .        . */
/*   .       .       .       .         .   .        .        . */

/*   U(1,9), V(1,9), U(2,9), V(2,9),  ...  U(64,9), V(64,9), 4 NULLS. */

/*               WE CHOOSE (ARBITRARILY) TO TRANSORM FIRST ALONG THE */
/*               DIRECTION OF THE FIRST SUBSCRIPT.  THUS WE DEFINE */
/*               THE LENGTH OF THE TRANSFORMS, N, TO BE 64, THE */
/*               NUMBER OF TRANSFORMS, LOT, TO BE 9, THE INCREMENT */
/*               BETWEEN ELEMENTS OF EACH TRANSFORM, INC, TO BE 1, */
/*               AND THE INCREMENT BETWEEN THE STARTING POINTS */
/*               FOR EACH TRANSFORM, JUMP, TO BE 66 (THE FIRST */
/*               DIMENSION OF A). */

/*               CALL CFFT99( A, WORK, TRIGS1, IFAX1, 1, 66, 64, 9, -1) */

/*               TO TRANSFORM ALONG THE DIRECTION OF THE SECOND SUBSCRIPT */
/*               THE ROLES OF THE INCREMENTS ARE REVERSED.  THUS WE DEFIN */
/*               THE LENGTH OF THE TRANSFORMS, N, TO BE 9, THE */
/*               NUMBER OF TRANSFORMS, LOT, TO BE 64, THE INCREMENT */
/*               BETWEEN ELEMENTS OF EACH TRANSFORM, INC, TO BE 66, */
/*               AND THE INCREMENT BETWEEN THE STARTING POINTS */
/*               FOR EACH TRANSFORM, JUMP, TO BE 1 */

/*               CALL CFFT99( A, WORK, TRIGS2, IFAX2, 66, 1, 9, 64, -1) */

/*               THESE TWO SEQUENTIAL STEPS RESULTS IN THE TWO-DIMENSIONA */
/*               FOURIER COEFFICIENT ARRAY OVERWRITING THE INPUT */
/*               GRIDPOINT ARRAY, A.  THE SAME TWO STEPS APPLIED AGAIN */
/*               WITH ISIGN = +1 WOULD RESULT IN THE RECONSTRUCTION OF */
/*               THE GRIDPOINT ARRAY (MULTIPLIED BY A FACTOR OF 64*9). */


/* ----------------------------------------------------------------------- */

/*     SUBROUTINE "CFFT99" - MULTIPLE FAST COMPLEX FOURIER TRANSFORM */

/*     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA */
/*     WORK IS AN AREA OF SIZE N*LOT */
/*     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES */
/*     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N */
/*     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR' */
/*         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA) */
/*     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR */
/*     N IS THE LENGTH OF THE DATA VECTORS */
/*     LOT IS THE NUMBER OF DATA VECTORS */
/*     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT */
/*           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL */


/*     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN */
/*     PARALLEL. */





    /* Parameter adjustments */
    --ifax;
    --trigs;
    --work;
    --a;

    /* Function Body */
    nn = *n + *n;
    ink = *inc + *inc;
    jum = *jump + *jump;
    nfax = ifax[1];
    jnk = 2;
    jst = 2;
    if (*isign >= 0) {
	goto L30;
    }

/*     THE INNERMOST TEMPERTON ROUTINES HAVE NO FACILITY FOR THE */
/*     FORWARD (ISIGN = -1) TRANSFORM.  THEREFORE, THE INPUT MUST BE */
/*     REARRANGED AS FOLLOWS: */

/*     THE ORDER OF EACH INPUT VECTOR, */

/*     G(0), G(1), G(2), ... , G(N-2), G(N-1) */

/*     IS REVERSED (EXCLUDING G(0)) TO YIELD */

/*     G(0), G(N-1), G(N-2), ... , G(2), G(1). */

/*     WITHIN THE TRANSFORM, THE CORRESPONDING EXPONENTIAL MULTIPLIER */
/*     IS THEN PRECISELY THE CONJUGATE OF THAT FOR THE NORMAL */
/*     ORDERING.  THUS THE FORWARD (ISIGN = -1) TRANSFORM IS */
/*     ACCOMPLISHED */

/*     FOR NFAX ODD, THE INPUT MUST BE TRANSFERRED TO THE WORK ARRAY, */
/*     AND THE REARRANGEMENT CAN BE DONE DURING THE MOVE. */

    jnk = -2;
    jst = nn - 2;
    if (nfax % 2 == 1) {
	goto L40;
    }

/*     FOR NFAX EVEN, THE REARRANGEMENT MUST BE APPLIED DIRECTLY TO */
/*     THE INPUT ARRAY.  THIS CAN BE DONE BY SWAPPING ELEMENTS. */

    ibase = 1;
    ilast = (*n - 1) * ink;
    nh = *n / 2;
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
	i1 = ibase + ink;
	i2 = ibase + ilast;
/* DIR$ IVDEP */
	ii2 = nh;
	for (m = 1; m <= ii2; ++m) {
/*     SWAP REAL AND IMAGINARY PORTIONS */
	    hreal = a[i1];
	    himag = a[i1 + 1];
	    a[i1] = a[i2];
	    a[i1 + 1] = a[i2 + 1];
	    a[i2] = hreal;
	    a[i2 + 1] = himag;
	    i1 += ink;
	    i2 -= ink;
/* L10: */
	}
	ibase += jum;
/* L20: */
    }
    goto L100;

L30:
    if (nfax % 2 == 0) {
	goto L100;
    }

L40:

/*     DURING THE TRANSFORM PROCESS, NFAX STEPS ARE TAKEN, AND THE */
/*     RESULTS ARE STORED ALTERNATELY IN WORK AND IN A.  IF NFAX IS */
/*     ODD, THE INPUT DATA ARE FIRST MOVED TO WORK SO THAT THE FINAL */
/*     RESULT (AFTER NFAX STEPS) IS STORED IN ARRAY A. */

    ibase = 1;
    jbase = 1;
    ii1 = *lot;
    for (l = 1; l <= ii1; ++l) {
/*     MOVE REAL AND IMAGINARY PORTIONS OF ELEMENT ZERO */
	work[jbase] = a[ibase];
	work[jbase + 1] = a[ibase + 1];
	ii = ibase + ink;
	j = jbase + jst;
/* DIR$ IVDEP */
	ii2 = *n;
	for (m = 2; m <= ii2; ++m) {
/*     MOVE REAL AND IMAGINARY PORTIONS OF OTHER ELEMENTS (POSSIBLY IN */
/*     REVERSE ORDER, DEPENDING ON JST AND JNK) */
	    work[j] = a[ii];
	    work[j + 1] = a[ii + 1];
	    ii += ink;
	    j += jnk;
/* L50: */
	}
	ibase += jum;
	jbase += nn;
/* L60: */
    }

L100:

/*     PERFORM THE TRANSFORM PASSES, ONE PASS FOR EACH FACTOR.  DURING */
/*     EACH PASS THE DATA ARE MOVED FROM A TO WORK OR FROM WORK TO A. */

/*     FOR NFAX EVEN, THE FIRST PASS MOVES FROM A TO WORK */
    igo = 110;
/*     FOR NFAX ODD, THE FIRST PASS MOVES FROM WORK TO A */
    if (nfax % 2 == 1) {
	igo = 120;
    }
    la = 1;
    ii1 = nfax;
    for (k = 1; k <= ii1; ++k) {
	if (igo == 120) {
	    goto L120;
	}
/* L110: */
	vpassm_(&a[1], &a[2], &work[1], &work[2], &trigs[1], &ink, &c2, &
		jum, &nn, lot, n, &ifax[k + 1], &la);
	igo = 120;
	goto L130;
L120:
	vpassm_(&work[1], &work[2], &a[1], &a[2], &trigs[1], &c2, &ink, &nn,
		 &jum, lot, n, &ifax[k + 1], &la);
	igo = 110;
L130:
	la *= ifax[k + 1];
/* L140: */
    }

/*     AT THIS POINT THE FINAL TRANSFORM RESULT IS STORED IN A. */

    return 0;
} /* cfft99_ */

/* Subroutine */ int cftfax_(integer *n, integer *ifax, doublereal *trigs)
{
    static integer k;
    extern /* Subroutine */ int fact_(integer *, integer *), cftrig_(integer *
	    , doublereal *), uliber_(void);


/*     THIS ROUTINE WAS MODIFIED FROM TEMPERTON"S ORIGINAL */
/*     BY DAVE FULKER.  IT NO LONGER PRODUCES FACTORS IN ASCENDING */
/*     ORDER, AND THERE ARE NONE OF THE ORIGINAL 'MODE' OPTIONS. */

/* ON INPUT     N */
/*               THE LENGTH OF EACH COMPLEX TRANSFORM TO BE PERFORMED */

/*               N MUST BE GREATER THAN 1 AND CONTAIN NO PRIME */
/*               FACTORS GREATER THAN 5. */

/* ON OUTPUT    IFAX */
/*               IFAX(1) */
/*                 THE NUMBER OF FACTORS CHOSEN OR -99 IN CASE OF ERROR */
/*               IFAX(2) THRU IFAX( IFAX(1)+1 ) */
/*                 THE FACTORS OF N IN THE FOLLOWIN ORDER:  APPEARING */
/*                 FIRST ARE AS MANY FACTORS OF 4 AS CAN BE OBTAINED. */
/*                 SUBSEQUENT FACTORS ARE PRIMES, AND APPEAR IN */
/*                 ASCENDING ORDER, EXCEPT FOR MULTIPLE FACTORS. */

/*              TRIGS */
/*               2N SIN AND COS VALUES FOR USE BY THE TRANSFORM ROUTINE */

    /* Parameter adjustments */
    --trigs;
    --ifax;

    /* Function Body */
    fact_(n, &ifax[1]);
    k = ifax[1];
    if (k < 1 || ifax[k + 1] > 5) {
	ifax[1] = -99;
    }
    if (ifax[1] <= 0) {
	uliber_();
    }
    cftrig_(n, &trigs[1]);
    return 0;
} /* cftfax_ */

/* Subroutine */ int fact_(integer *n, integer *ifax)
{
    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer k, l, nn, inc, max__;

/*     FACTORIZATION ROUTINE THAT FIRST EXTRACTS ALL FACTORS OF 4 */
    /* Parameter adjustments */
    --ifax;

    /* Function Body */
    if (*n > 1) {
	goto L10;
    }
    ifax[1] = 0;
    if (*n < 1) {
	ifax[1] = -99;
    }
    return 0;
L10:
    nn = *n;
    k = 1;
/*     TEST FOR FACTORS OF 4 */
L20:
    if (nn % 4 != 0) {
	goto L30;
    }
    ++k;
    ifax[k] = 4;
    nn /= 4;
    if (nn == 1) {
	goto L80;
    }
    goto L20;
/*     TEST FOR EXTRA FACTOR OF 2 */
L30:
    if (nn % 2 != 0) {
	goto L40;
    }
    ++k;
    ifax[k] = 2;
    nn /= 2;
    if (nn == 1) {
	goto L80;
    }
/*     TEST FOR FACTORS OF 3 */
L40:
    if (nn % 3 != 0) {
	goto L50;
    }
    ++k;
    ifax[k] = 3;
    nn /= 3;
    if (nn == 1) {
	goto L80;
    }
    goto L40;
/*     NOW FIND REMAINING FACTORS */
L50:
    l = 5;
    max__ = sqrt((real) nn);
    inc = 2;
/*     INC ALTERNATELY TAKES ON VALUES 2 AND 4 */
L60:
    if (nn % l != 0) {
	goto L70;
    }
    ++k;
    ifax[k] = l;
    nn /= l;
    if (nn == 1) {
	goto L80;
    }
    goto L60;
L70:
    if (l > max__) {
	goto L75;
    }
    l += inc;
    inc = 6 - inc;
    goto L60;
L75:
    ++k;
    ifax[k] = nn;
L80:
    ifax[1] = k - 1;
/*     IFAX(1) NOW CONTAINS NUMBER OF FACTORS */
    return 0;
} /* fact_ */

/* Subroutine */ int cftrig_(integer *n, doublereal *trigs)
{
    /* System generated locals */
    integer ii1;

    /* Builtin functions */
    double asin(doublereal), cos(doublereal), sin(doublereal);

    /* Local variables */
    static integer ii, l;
    static doublereal pi, del, angle;

    /* Parameter adjustments */
    --trigs;

    /* Function Body */
    pi = asin(1.) * 2.;
    del = (pi + pi) / (doublereal) (*n);
    l = *n + *n;
    ii1 = l;
    for (ii = 1; ii <= ii1; ii += 2) {
	angle = (doublereal) (ii - 1) * .5 * del;
	trigs[ii] = cos(angle);
	trigs[ii + 1] = sin(angle);
/* L10: */
    }
    return 0;
} /* cftrig_ */

/* Subroutine */ int vpassm_(doublereal *a, doublereal *b, doublereal *c, 
	doublereal *d__, doublereal *trigs, integer *inc1, integer *inc2, 
	integer *inc3, integer *inc4, integer *lot, integer *n, integer *ifac,
	 integer *la)
{
    /* Initialized data */

    static doublereal sin36 = .587785252292473;
    static doublereal cos36 = .809016994374947;
    static doublereal sin72 = .951056516295154;
    static doublereal cos72 = .309016994374947;
    static doublereal sin60 = .866025403784437;

    /* System generated locals */
    integer ii1, ii2, ii3, ii4;

    /* Local variables */
    static integer ii, j, k, l, m;
    static doublereal c1, c2, c3, c4, s1, s2, s3, s4;
    static integer ia, ja, ib, jb, kb, ic, jc, kc, id, jd, kd, ie, je, ke, 
	    la1, ijk, igo, iink, jink, jump, ibase, jbase;

/*      do i=1,n */
/*       write(*,*) a(i),b(i),c(i),d(i) */
/*      end do */

/*     SUBROUTINE "VPASSM" - MULTIPLE VERSION OF "VPASSA" */
/*     PERFORMS ONE PASS THROUGH DATA */
/*     AS PART OF MULTIPLE COMPLEX (INVERSE) FFT ROUTINE */
/*     A IS FIRST REAL INPUT VECTOR */
/*     B IS FIRST IMAGINARY INPUT VECTOR */
/*     C IS FIRST REAL OUTPUT VECTOR */
/*     D IS FIRST IMAGINARY OUTPUT VECTOR */
/*     TRIGS IS PRECALCULATED TABLE OF SINES & COSINES */
/*     INC1 IS ADDRESSING INCREMENT FOR A AND B */
/*     INC2 IS ADDRESSING INCREMENT FOR C AND D */
/*     INC3 IS ADDRESSING INCREMENT BETWEEN A"S & B"S */
/*     INC4 IS ADDRESSING INCREMENT BETWEEN C"S & D"S */
/*     LOT IS THE NUMBER OF VECTORS */
/*     N IS LENGTH OF VECTORS */
/*     IFAC IS CURRENT FACTOR OF N */
/*     LA IS PRODUCT OF PREVIOUS FACTORS */

    /* Parameter adjustments */
    --trigs;
    --d__;
    --c;
    --b;
    --a;

    /* Function Body */

    m = *n / *ifac;
    iink = m * *inc1;
    jink = *la * *inc2;
    jump = (*ifac - 1) * jink;
    ibase = 0;
    jbase = 0;
    igo = *ifac - 1;
    if (igo > 4) {
	return 0;
    }
    switch (igo) {
	case 1:  goto L10;
	case 2:  goto L50;
	case 3:  goto L90;
	case 4:  goto L130;
    }

/*     CODING FOR FACTOR 2 */

L10:
    ia = 1;
    ja = 1;
    ib = ia + iink;
    jb = ja + jink;
    ii1 = *la;
    for (l = 1; l <= ii1; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii2 = *lot;
	for (ijk = 1; ijk <= ii2; ++ijk) {
	    c[ja + j] = a[ia + ii] + a[ib + ii];
	    d__[ja + j] = b[ia + ii] + b[ib + ii];
	    c[jb + j] = a[ia + ii] - a[ib + ii];
	    d__[jb + j] = b[ia + ii] - b[ib + ii];
	    ii += *inc3;
	    j += *inc4;
/* L15: */
	}
	ibase += *inc1;
	jbase += *inc2;
/* L20: */
    }
    if (*la == m) {
	return 0;
    }
    la1 = *la + 1;
    jbase += jump;
    ii1 = m;
    ii2 = *la;
    for (k = la1; ii2 < 0 ? k >= ii1 : k <= ii1; k += ii2) {
	kb = k + k - 2;
	c1 = trigs[kb + 1];
	s1 = trigs[kb + 2];
	ii3 = *la;
	for (l = 1; l <= ii3; ++l) {
	    ii = ibase;
	    j = jbase;
/* DIR$ IVDEP */
	    ii4 = *lot;
	    for (ijk = 1; ijk <= ii4; ++ijk) {
		c[ja + j] = a[ia + ii] + a[ib + ii];
		d__[ja + j] = b[ia + ii] + b[ib + ii];
		c[jb + j] = c1 * (a[ia + ii] - a[ib + ii]) - s1 * (b[ia + 
			ii] - b[ib + ii]);
		d__[jb + j] = s1 * (a[ia + ii] - a[ib + ii]) + c1 * (b[ia + 
			ii] - b[ib + ii]);
		ii += *inc3;
		j += *inc4;
/* L25: */
	    }
	    ibase += *inc1;
	    jbase += *inc2;
/* L30: */
	}
	jbase += jump;
/* L40: */
    }
    return 0;

/*     CODING FOR FACTOR 3 */

/* ----------------------------------------------------------------------- */
L50:
    ia = 1;
    ja = 1;
    ib = ia + iink;
    jb = ja + jink;
    ic = ib + iink;
    jc = jb + jink;
    ii2 = *la;
    for (l = 1; l <= ii2; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii1 = *lot;
	for (ijk = 1; ijk <= ii1; ++ijk) {
	    c[ja + j] = a[ia + ii] + (a[ib + ii] + a[ic + ii]);
	    d__[ja + j] = b[ia + ii] + (b[ib + ii] + b[ic + ii]);
	    c[jb + j] = a[ia + ii] - (a[ib + ii] + a[ic + ii]) * .5 - 
		    sin60 * (b[ib + ii] - b[ic + ii]);
	    c[jc + j] = a[ia + ii] - (a[ib + ii] + a[ic + ii]) * .5 + 
		    sin60 * (b[ib + ii] - b[ic + ii]);
	    d__[jb + j] = b[ia + ii] - (b[ib + ii] + b[ic + ii]) * .5 + 
		    sin60 * (a[ib + ii] - a[ic + ii]);
	    d__[jc + j] = b[ia + ii] - (b[ib + ii] + b[ic + ii]) * .5 - 
		    sin60 * (a[ib + ii] - a[ic + ii]);
	    ii += *inc3;
	    j += *inc4;
/* L55: */
	}
	ibase += *inc1;
	jbase += *inc2;
/* L60: */
    }
    if (*la == m) {
	return 0;
    }
    la1 = *la + 1;
    jbase += jump;
    ii2 = m;
    ii1 = *la;
    for (k = la1; ii1 < 0 ? k >= ii2 : k <= ii2; k += ii1) {
	kb = k + k - 2;
	kc = kb + kb;
	c1 = trigs[kb + 1];
	s1 = trigs[kb + 2];
	c2 = trigs[kc + 1];
	s2 = trigs[kc + 2];
	ii3 = *la;
	for (l = 1; l <= ii3; ++l) {
	    ii = ibase;
	    j = jbase;
/* DIR$ IVDEP */
	    ii4 = *lot;
	    for (ijk = 1; ijk <= ii4; ++ijk) {
		c[ja + j] = a[ia + ii] + (a[ib + ii] + a[ic + ii]);
		d__[ja + j] = b[ia + ii] + (b[ib + ii] + b[ic + ii]);
		c[jb + j] = c1 * (a[ia + ii] - (a[ib + ii] + a[ic + ii]) 
			* .5 - sin60 * (b[ib + ii] - b[ic + ii])) - s1 * (b[
			ia + ii] - (b[ib + ii] + b[ic + ii]) * .5 + sin60 *
			 (a[ib + ii] - a[ic + ii]));
		d__[jb + j] = s1 * (a[ia + ii] - (a[ib + ii] + a[ic + ii]) 
			* .5 - sin60 * (b[ib + ii] - b[ic + ii])) + c1 * (b[
			ia + ii] - (b[ib + ii] + b[ic + ii]) * .5 + sin60 *
			 (a[ib + ii] - a[ic + ii]));
		c[jc + j] = c2 * (a[ia + ii] - (a[ib + ii] + a[ic + ii]) 
			* .5f + sin60 * (b[ib + ii] - b[ic + ii])) - s2 * (
			b[ia + ii] - (b[ib + ii] + b[ic + ii]) * .5 - 
			sin60 * (a[ib + ii] - a[ic + ii]));
		d__[jc + j] = s2 * (a[ia + ii] - (a[ib + ii] + a[ic + ii]) 
			* .5 + sin60 * (b[ib + ii] - b[ic + ii])) + c2 * (b[
			ia + ii] - (b[ib + ii] + b[ic + ii]) * .5 - sin60 *
			 (a[ib + ii] - a[ic + ii]));
		ii += *inc3;
		j += *inc4;
/* L65: */
	    }
	    ibase += *inc1;
	    jbase += *inc2;
/* L70: */
	}
	jbase += jump;
/* L80: */
    }
    return 0;

/*     CODING FOR FACTOR 4 */

L90:
    ia = 1;
    ja = 1;
    ib = ia + iink;
    jb = ja + jink;
    ic = ib + iink;
    jc = jb + jink;
    id = ic + iink;
    jd = jc + jink;
    ii1 = *la;
    for (l = 1; l <= ii1; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii2 = *lot;
	for (ijk = 1; ijk <= ii2; ++ijk) {
	    c[ja + j] = a[ia + ii] + a[ic + ii] + (a[ib + ii] + a[id + 
		    ii]);
	    c[jc + j] = a[ia + ii] + a[ic + ii] - (a[ib + ii] + a[id + 
		    ii]);
	    d__[ja + j] = b[ia + ii] + b[ic + ii] + (b[ib + ii] + b[id + 
		    ii]);
	    d__[jc + j] = b[ia + ii] + b[ic + ii] - (b[ib + ii] + b[id + 
		    ii]);
	    c[jb + j] = a[ia + ii] - a[ic + ii] - (b[ib + ii] - b[id + 
		    ii]);
	    c[jd + j] = a[ia + ii] - a[ic + ii] + (b[ib + ii] - b[id + 
		    ii]);
	    d__[jb + j] = b[ia + ii] - b[ic + ii] + (a[ib + ii] - a[id + 
		    ii]);
	    d__[jd + j] = b[ia + ii] - b[ic + ii] - (a[ib + ii] - a[id + 
		    ii]);
	    ii += *inc3;
	    j += *inc4;
/* L95: */
	}
	ibase += *inc1;
	jbase += *inc2;
/* L100: */
    }
    if (*la == m) {
	return 0;
    }
    la1 = *la + 1;
    jbase += jump;
    ii1 = m;
    ii2 = *la;
    for (k = la1; ii2 < 0 ? k >= ii1 : k <= ii1; k += ii2) {
	kb = k + k - 2;
	kc = kb + kb;
	kd = kc + kb;
	c1 = trigs[kb + 1];
	s1 = trigs[kb + 2];
	c2 = trigs[kc + 1];
	s2 = trigs[kc + 2];
	c3 = trigs[kd + 1];
	s3 = trigs[kd + 2];
	ii3 = *la;
	for (l = 1; l <= ii3; ++l) {
	    ii = ibase;
	    j = jbase;
/* DIR$ IVDEP */
	    ii4 = *lot;
	    for (ijk = 1; ijk <= ii4; ++ijk) {
		c[ja + j] = a[ia + ii] + a[ic + ii] + (a[ib + ii] + a[id 
			+ ii]);
		d__[ja + j] = b[ia + ii] + b[ic + ii] + (b[ib + ii] + b[id 
			+ ii]);
		c[jc + j] = c2 * (a[ia + ii] + a[ic + ii] - (a[ib + ii] 
			+ a[id + ii])) - s2 * (b[ia + ii] + b[ic + ii] - (
			b[ib + ii] + b[id + ii]));
		d__[jc + j] = s2 * (a[ia + ii] + a[ic + ii] - (a[ib + ii] 
			+ a[id + ii])) + c2 * (b[ia + ii] + b[ic + ii] - (
			b[ib + ii] + b[id + ii]));
		c[jb + j] = c1 * (a[ia + ii] - a[ic + ii] - (b[ib + ii] 
			- b[id + ii])) - s1 * (b[ia + ii] - b[ic + ii] + (
			a[ib + ii] - a[id + ii]));
		d__[jb + j] = s1 * (a[ia + ii] - a[ic + ii] - (b[ib + ii] 
			- b[id + ii])) + c1 * (b[ia + ii] - b[ic + ii] + (
			a[ib + ii] - a[id + ii]));
		c[jd + j] = c3 * (a[ia + ii] - a[ic + ii] + (b[ib + ii] 
			- b[id + ii])) - s3 * (b[ia + ii] - b[ic + ii] - (
			a[ib + ii] - a[id + ii]));
		d__[jd + j] = s3 * (a[ia + ii] - a[ic + ii] + (b[ib + ii] 
			- b[id + ii])) + c3 * (b[ia + ii] - b[ic + ii] - (
			a[ib + ii] - a[id + ii]));
		ii += *inc3;
		j += *inc4;
/* L105: */
	    }
	    ibase += *inc1;
	    jbase += *inc2;
/* L110: */
	}
	jbase += jump;
/* L120: */
    }
    return 0;

/*     CODING FOR FACTOR 5 */

L130:
    ia = 1;
    ja = 1;
    ib = ia + iink;
    jb = ja + jink;
    ic = ib + iink;
    jc = jb + jink;
    id = ic + iink;
    jd = jc + jink;
    ie = id + iink;
    je = jd + jink;
    ii2 = *la;
    for (l = 1; l <= ii2; ++l) {
	ii = ibase;
	j = jbase;
/* DIR$ IVDEP */
	ii1 = *lot;
	for (ijk = 1; ijk <= ii1; ++ijk) {
	    c[ja + j] = a[ia + ii] + (a[ib + ii] + a[ie + ii]) + (a[ic + 
		    ii] + a[id + ii]);
	    d__[ja + j] = b[ia + ii] + (b[ib + ii] + b[ie + ii]) + (b[ic + 
		    ii] + b[id + ii]);
	    c[jb + j] = a[ia + ii] + cos72 * (a[ib + ii] + a[ie + ii]) - 
		    cos36 * (a[ic + ii] + a[id + ii]) - (sin72 * (b[ib + 
		    ii] - b[ie + ii]) + sin36 * (b[ic + ii] - b[id + ii]))
		    ;
	    c[je + j] = a[ia + ii] + cos72 * (a[ib + ii] + a[ie + ii]) - 
		    cos36 * (a[ic + ii] + a[id + ii]) + (sin72 * (b[ib + 
		    ii] - b[ie + ii]) + sin36 * (b[ic + ii] - b[id + ii]))
		    ;
	    d__[jb + j] = b[ia + ii] + cos72 * (b[ib + ii] + b[ie + ii]) - 
		    cos36 * (b[ic + ii] + b[id + ii]) + (sin72 * (a[ib + 
		    ii] - a[ie + ii]) + sin36 * (a[ic + ii] - a[id + ii]))
		    ;
	    d__[je + j] = b[ia + ii] + cos72 * (b[ib + ii] + b[ie + ii]) - 
		    cos36 * (b[ic + ii] + b[id + ii]) - (sin72 * (a[ib + 
		    ii] - a[ie + ii]) + sin36 * (a[ic + ii] - a[id + ii]))
		    ;
	    c[jc + j] = a[ia + ii] - cos36 * (a[ib + ii] + a[ie + ii]) + 
		    cos72 * (a[ic + ii] + a[id + ii]) - (sin36 * (b[ib + 
		    ii] - b[ie + ii]) - sin72 * (b[ic + ii] - b[id + ii]))
		    ;
	    c[jd + j] = a[ia + ii] - cos36 * (a[ib + ii] + a[ie + ii]) + 
		    cos72 * (a[ic + ii] + a[id + ii]) + (sin36 * (b[ib + 
		    ii] - b[ie + ii]) - sin72 * (b[ic + ii] - b[id + ii]))
		    ;
	    d__[jc + j] = b[ia + ii] - cos36 * (b[ib + ii] + b[ie + ii]) + 
		    cos72 * (b[ic + ii] + b[id + ii]) + (sin36 * (a[ib + 
		    ii] - a[ie + ii]) - sin72 * (a[ic + ii] - a[id + ii]))
		    ;
	    d__[jd + j] = b[ia + ii] - cos36 * (b[ib + ii] + b[ie + ii]) + 
		    cos72 * (b[ic + ii] + b[id + ii]) - (sin36 * (a[ib + 
		    ii] - a[ie + ii]) - sin72 * (a[ic + ii] - a[id + ii]))
		    ;
	    ii += *inc3;
	    j += *inc4;
/* L135: */
	}
	ibase += *inc1;
	jbase += *inc2;
/* L140: */
    }
    if (*la == m) {
	return 0;
    }
    la1 = *la + 1;
    jbase += jump;
    ii2 = m;
    ii1 = *la;
    for (k = la1; ii1 < 0 ? k >= ii2 : k <= ii2; k += ii1) {
	kb = k + k - 2;
	kc = kb + kb;
	kd = kc + kb;
	ke = kd + kb;
	c1 = trigs[kb + 1];
	s1 = trigs[kb + 2];
	c2 = trigs[kc + 1];
	s2 = trigs[kc + 2];
	c3 = trigs[kd + 1];
	s3 = trigs[kd + 2];
	c4 = trigs[ke + 1];
	s4 = trigs[ke + 2];
	ii3 = *la;
	for (l = 1; l <= ii3; ++l) {
	    ii = ibase;
	    j = jbase;
/* DIR$ IVDEP */
	    ii4 = *lot;
	    for (ijk = 1; ijk <= ii4; ++ijk) {
		c[ja + j] = a[ia + ii] + (a[ib + ii] + a[ie + ii]) + (a[
			ic + ii] + a[id + ii]);
		d__[ja + j] = b[ia + ii] + (b[ib + ii] + b[ie + ii]) + (b[
			ic + ii] + b[id + ii]);
		c[jb + j] = c1 * (a[ia + ii] + cos72 * (a[ib + ii] + a[ie 
			+ ii]) - cos36 * (a[ic + ii] + a[id + ii]) - (
			sin72 * (b[ib + ii] - b[ie + ii]) + sin36 * (b[ic + 
			ii] - b[id + ii]))) - s1 * (b[ia + ii] + cos72 * (
			b[ib + ii] + b[ie + ii]) - cos36 * (b[ic + ii] + b[
			id + ii]) + (sin72 * (a[ib + ii] - a[ie + ii]) + 
			sin36 * (a[ic + ii] - a[id + ii])));
		d__[jb + j] = s1 * (a[ia + ii] + cos72 * (a[ib + ii] + a[ie 
			+ ii]) - cos36 * (a[ic + ii] + a[id + ii]) - (
			sin72 * (b[ib + ii] - b[ie + ii]) + sin36 * (b[ic + 
			ii] - b[id + ii]))) + c1 * (b[ia + ii] + cos72 * (
			b[ib + ii] + b[ie + ii]) - cos36 * (b[ic + ii] + b[
			id + ii]) + (sin72 * (a[ib + ii] - a[ie + ii]) + 
			sin36 * (a[ic + ii] - a[id + ii])));
		c[je + j] = c4 * (a[ia + ii] + cos72 * (a[ib + ii] + a[ie 
			+ ii]) - cos36 * (a[ic + ii] + a[id + ii]) + (
			sin72 * (b[ib + ii] - b[ie + ii]) + sin36 * (b[ic + 
			ii] - b[id + ii]))) - s4 * (b[ia + ii] + cos72 * (
			b[ib + ii] + b[ie + ii]) - cos36 * (b[ic + ii] + b[
			id + ii]) - (sin72 * (a[ib + ii] - a[ie + ii]) + 
			sin36 * (a[ic + ii] - a[id + ii])));
		d__[je + j] = s4 * (a[ia + ii] + cos72 * (a[ib + ii] + a[ie 
			+ ii]) - cos36 * (a[ic + ii] + a[id + ii]) + (
			sin72 * (b[ib + ii] - b[ie + ii]) + sin36 * (b[ic + 
			ii] - b[id + ii]))) + c4 * (b[ia + ii] + cos72 * (
			b[ib + ii] + b[ie + ii]) - cos36 * (b[ic + ii] + b[
			id + ii]) - (sin72 * (a[ib + ii] - a[ie + ii]) + 
			sin36 * (a[ic + ii] - a[id + ii])));
		c[jc + j] = c2 * (a[ia + ii] - cos36 * (a[ib + ii] + a[ie 
			+ ii]) + cos72 * (a[ic + ii] + a[id + ii]) - (
			sin36 * (b[ib + ii] - b[ie + ii]) - sin72 * (b[ic + 
			ii] - b[id + ii]))) - s2 * (b[ia + ii] - cos36 * (
			b[ib + ii] + b[ie + ii]) + cos72 * (b[ic + ii] + b[
			id + ii]) + (sin36 * (a[ib + ii] - a[ie + ii]) - 
			sin72 * (a[ic + ii] - a[id + ii])));
		d__[jc + j] = s2 * (a[ia + ii] - cos36 * (a[ib + ii] + a[ie 
			+ ii]) + cos72 * (a[ic + ii] + a[id + ii]) - (
			sin36 * (b[ib + ii] - b[ie + ii]) - sin72 * (b[ic + 
			ii] - b[id + ii]))) + c2 * (b[ia + ii] - cos36 * (
			b[ib + ii] + b[ie + ii]) + cos72 * (b[ic + ii] + b[
			id + ii]) + (sin36 * (a[ib + ii] - a[ie + ii]) - 
			sin72 * (a[ic + ii] - a[id + ii])));
		c[jd + j] = c3 * (a[ia + ii] - cos36 * (a[ib + ii] + a[ie 
			+ ii]) + cos72 * (a[ic + ii] + a[id + ii]) + (
			sin36 * (b[ib + ii] - b[ie + ii]) - sin72 * (b[ic + 
			ii] - b[id + ii]))) - s3 * (b[ia + ii] - cos36 * (
			b[ib + ii] + b[ie + ii]) + cos72 * (b[ic + ii] + b[
			id + ii]) - (sin36 * (a[ib + ii] - a[ie + ii]) - 
			sin72 * (a[ic + ii] - a[id + ii])));
		d__[jd + j] = s3 * (a[ia + ii] - cos36 * (a[ib + ii] + a[ie 
			+ ii]) + cos72 * (a[ic + ii] + a[id + ii]) + (
			sin36 * (b[ib + ii] - b[ie + ii]) - sin72 * (b[ic + 
			ii] - b[id + ii]))) + c3 * (b[ia + ii] - cos36 * (
			b[ib + ii] + b[ie + ii]) + cos72 * (b[ic + ii] + b[
			id + ii]) - (sin36 * (a[ib + ii] - a[ie + ii]) - 
			sin72 * (a[ic + ii] - a[id + ii])));
		ii += *inc3;
		j += *inc4;
/* L145: */
	    }
	    ibase += *inc1;
	    jbase += *inc2;
/* L150: */
	}
	jbase += jump;
/* L160: */
    }
    return 0;
} /* vpassm_ */

/* ***************************** */
/* you need theses subroutines */
/* not coming from xmp */
/* ***************************** */
/* missing subroutines */
/* Subroutine */ int uliber_(void)
{
/*     print * , ' uliber' */
    return 0;
} /* uliber_ */




#endif
