#ifndef _GL_MATRIX
#define _GL_MATRIX


void glTransform(float x, float y, float z, float *tx, float *ty, float *tz)
{
GLdouble m[16];

 glGetDoublev (GL_MODELVIEW_MATRIX, m);

 *tx = m[0]*x + m[1]*y + m[2]*z  + m[3];
 *ty = m[4]*x + m[5]*y + m[6]*z  + m[7];
 *tz = m[8]*x + m[9]*y + m[10]*z + m[11];

}




void glProject(float x, float y, float z, float *win_x, float *win_y)
{
GLint viewport[4];
GLdouble mvmatrix[16], projmatrix[16];
GLdouble wx, wy, wz; /* returned window x, y, z coords */

 glGetIntegerv (GL_VIEWPORT, viewport);
 glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
 glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);

/*
int gluProject(GLdouble objx, GLdouble objy, GLdouble objz, 
               const GLdouble modelMatrix[16],
							 const GLdouble projMatrix[16],
							 const GLint viewport[4],
							 GLdouble *winx, GLdouble *winy, GLdouble*winz);
*/
    gluProject(x, y, z, 
               mvmatrix, projmatrix, viewport,
							 &wx, &wy, &wz);

  //printf ("Projexted coords for (%.2f,%.2f,%.2f) are (%.2f,%.2f)\n", x,y,z, wx, wy, wz);


  *win_x = wx;
	*win_y = wy;

}


void glUnProject(float win_x, float win_y, float win_z,  float *w_x, float *w_y, float *w_z)
{
GLint viewport[4];
GLdouble mvmatrix[16], projmatrix[16];
GLint realy; /* OpenGL y coordinate position */
GLdouble wx, wy, wz; /* returned world x, y, z coords */

 glGetIntegerv (GL_VIEWPORT, viewport);
 glGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix);
 glGetDoublev (GL_PROJECTION_MATRIX, projmatrix);

/* note viewport[3] is height of window in pixels */
 realy = viewport[3] - (GLint) win_y - 1;

 printf ("Coordinates at cursor are (%4d, %4d)\n", win_x, realy);

 gluUnProject (win_x, realy, 0.0, mvmatrix, projmatrix, viewport,   &wx, &wy, &wz);
  printf ("World coords at z=0.0 are (%f, %f, %f)\n", wx, wy, wz);

	*w_x = wx;
	*w_y = wy;
	*w_z = wz;

}



#endif
