//*************************************************************************
// GLSL Tutorial
//*************************************************************************

#include <stdio.h>
#include <string.h>

/*
#include "glew.h"
#include "glsl.h"
*/
#include "glut.h"
#include "glmatrix.h"

#include "globals.h"

#include "compute.h"

#include "tac.h"

#include "texture.h"

#include "marching_cubes.h"

#include "draw.h"

#include "assi.h"

#include "mouse.h"

#include "trackball.h"


void glInit()
{
	// Init Render state
	glClearColor(.7,.7,.7,1);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	glShadeModel(GL_SMOOTH);

	   glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

	init_palettes();
  materials_init();



	//glEnable(GL_CULL_FACE);

/*
	
	glewInit();

	if (!GLEW_ARB_vertex_shader || !GLEW_ARB_fragment_shader) printf("Cannot find GLSL ARB Extensions!\n");

    glslLoad();
*/

//*****************
glEnable(GL_LINE_SMOOTH);
glLineWidth(1);
glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
//*****************


}







void view_reset(void)
{
 trackball(g_quat, 0.0, 0.0, 0.0, -10.0);
 g_oz=-4.0;
 g_ox=g_oy=0.0;
}




void display(void)
{

//glLoadIdentity();






//glUseProgramObjectARB(arb_ptr[3]);

#ifdef TAC

if(g_draw_iso)
{
glColor4f(1,.5,0,1.0);
//
glDisable(GL_TEXTURE_1D);


glEnable(GL_LIGHTING);
glEnable(GL_DEPTH_TEST);
glDepthMask(GL_TRUE);

draw_iso(1, g_my_iso);
}

#endif

if(g_draw_vol)
{

glEnable(GL_TEXTURE_1D);
select_palette(1);
//
glDisable(GL_LIGHTING);

glDepthMask(GL_FALSE);
 glDisable(GL_DEPTH_TEST);
 glColor3f(1,1,1);

 select_palette(1);
 draw_volume(4, 0.0, 0.0);

glDepthMask(GL_TRUE);

}


glDisable(GL_LIGHTING);
disegna_assi();



#ifndef TAC

 glColor4f(0,0,0,1);
 glCallList( g_display_glyphs );

#endif


//glDisable(GL_DEPTH_TEST);
glEnable(GL_DEPTH_TEST);
glColor4f(0.3,0.2,0.8,0.6);
glutWireCube(2.0);



}
















void display_main(void)
{
//if(g_stereo)
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);

	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );


  glLoadIdentity();
	 glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
   glLightfv(GL_LIGHT0, GL_SPECULAR, lightCol);



    glLoadIdentity();

    build_rotmatrix(g_MyMatrix[0], g_quat);

  



if(!g_stereo)
{
	
	glLoadIdentity();

  glTranslatef(g_ox,g_oy,g_oz);	


  glMultMatrixf(&g_MyMatrix[0][0][0]);

  display();

}
else
for(int i=0; i<2; i++)
{

glLoadIdentity();



// void glColorMask( GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha )
if(!i)
{
 glTranslatef(.02*512.0/(g_w+1.0),0,0);

 glColorMask( GL_TRUE,  GL_FALSE, GL_FALSE, GL_FALSE );
}
else
{
 glTranslatef(-.02*512.0/(g_w+1.0),0,0);

  glColorMask( GL_FALSE, GL_TRUE, GL_TRUE, GL_FALSE );

	glClear(GL_DEPTH_BUFFER_BIT );
}


  glTranslatef(g_ox,g_oy,g_oz);	

  glMultMatrixf(&g_MyMatrix[0][0][0]);

  display();

}


glFlush();

glutSwapBuffers();

MouseRefresh( &g_Mouse );

}








void reshape(int w, int h)
{
	g_w = w;
	g_h = h;
	if (h == 0) return;

	glMatrixMode(GL_PROJECTION);

	glLoadIdentity();
    glViewport(0, 0, w, h);
	gluPerspective(60, (float)w/h, 0.125, 128);

	glMatrixMode(GL_MODELVIEW);

    glutPostRedisplay();

}









void keyboard(unsigned char key, int x, int y)
{
	if (key == 27) exit(0);

	if (key == 'a') g_oz+=.1;
	if (key == 'z') g_oz-=.1;

	if (key == 's')  if(g_my_iso > 0.05) g_my_iso-=.05;
	if (key == 'x')  if(g_my_iso < 10.0) g_my_iso+=.05;

	if (key == 'v') g_draw_vol = !g_draw_vol;
	if (key == 'i') g_draw_iso = !g_draw_iso;

	if (key == 'q') g_stereo = !g_stereo;

	if (key == 'r') view_reset(); 

//	printf("key: %i (%i,%i)\n", key, x, y);
	glutPostRedisplay();

}





void main(int argc, char **argv)
{
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA | GLUT_MULTISAMPLE);

	glutInitWindowPosition(10,10);
	glutInitWindowSize(500,500);
	glutCreateWindow(argv[0]);

	glutDisplayFunc(display_main);
// glutIdleFunc(idle);

	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);

	glutMouseFunc(mouseFunction);
	glutMotionFunc(mouseMotion);

    glInit();


#ifndef TAC
   g_grid_vals = get_parse("dati.txt", "precalc.dat", "glyphs.dat");
#else
//   g_grid_vals = get_tac16("C:\\MyDev\\models\\fullHead\\", "headsq", 94, 256,256,2,0x7FFF);
   g_grid_vals = get_tac16("fullHead\\", "headsq", 94, 256,256,2,0x7FFF);
#endif

#ifdef TAC
{
int i,j,k;
float x,y,z;
float dx,dy,dz;
int  off=0;

dx=2.0/(float)DIM_X;
dy=2.0/(float)DIM_Y;
dz=2.0/(float)DIM_Z;

	 for(k=0, z=1; k<DIM_Z; k++, z-=dz)
		 for(j=0, y=-1; j<DIM_Y; j++, y+=dy)
			 for(i=0, x=-1; i<DIM_X; i++, x+=dx, off++)
			  if(x*x+y*y > 1.0) g_grid_vals[off] = 0.0;

}

// passabasso veloce
for(int s=0; s<2; s++)
{
int i,j,k;
int  off=1+DIM_X+DIM_X*DIM_Y;

	 for(k=1; k<DIM_Z-1; k++, off+=DIM_X*2)
		 for(j=1; j<DIM_Y-1; j++, off+=2)
			 for(i=1; i<DIM_X-1; i++, off++)
			 {  
				 g_grid_vals[off] = (g_grid_vals[off]*4.0+
					                   g_grid_vals[off-1]+
					                   g_grid_vals[off+1]+
									           g_grid_vals[off-DIM_X]+
									           g_grid_vals[off+DIM_X]+
									           g_grid_vals[off-DIM_X*DIM_Y]+
									           g_grid_vals[off+DIM_X*DIM_Y]) / 10.0;
									 
				 
			 }

}
#endif


view_reset();

	glutMainLoop();
	
	
	free(g_grid_vals);
}

