#ifndef _TAC
#define _TAC

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <math.h>


float *get_tac16(char *path, char *radix, int num_slices, int x_res, int y_res, size_t Bpv, int mask)
{
 float *dest, *ptr;
 void *tmp;
 int max_dim = x_res*y_res*Bpv*num_slices; 

 ptr = dest = (float *)malloc( (max_dim) * sizeof(float) );

 if(dest == NULL) 
 {
	 printf("errore di allocazione della memoria! (%i bytes)\n", max_dim);
	 return NULL;
 }
 memset(ptr, 0, (max_dim) * sizeof(float));



char file_name[256];
tmp = (short *)malloc( (x_res*y_res) * Bpv );

 if(tmp == NULL) 
 {
	 printf("errore di allocazione della memoria! (%i bytes)\n", max_dim);
	 free(dest);
	 return NULL;
 }


printf("Inizio lettura file\n");
for(int i=0; i<num_slices; i++)
{
 sprintf(file_name, "%s%s.%i", path, radix, (i+1));
 
 FILE *fp = fopen( file_name, "rb");

 if(fp == NULL)
 {
	 printf("errore nell'aprire il file di origine! (%s)\n", file_name);
	 return NULL;
 }


printf("lettura file #%i: '%s'... \n", i+1, file_name);
fread((void *)tmp, x_res*y_res, Bpv, fp);
fclose(fp);

printf("fatto, conversione dati... ");
short *src = (short *)tmp;
float k_mul = 1.0 / pow(2, Bpv*8-1);
float val;
for(int k=0; k<x_res*y_res; k++)
{
 *dest = val = ((*src) & mask) * k_mul;
 dest++;
 src++;

   if( val < g_min_val) g_min_val = val;
    else
   if( val > g_max_val) g_max_val = val;

   g_avg_val += val;
}


printf("\nslice %i di %i fatto.\n\n", i+1, num_slices);


}
g_avg_val /= (float)(x_res*y_res*num_slices);


printf("\n-----------------\n - valore minimo calcolato: %f\n - valore massimo calcolato: %f\n valore medio: %f\n", g_min_val, g_max_val, g_avg_val); 


free(tmp);





for(i=0; i<DIM_X*DIM_Y*DIM_Z; i++)
	 ptr[i] = ptr[i] / g_max_val;


return ptr;

}





#endif
